// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import freemind.main.FreeMindMain;
import freemind.modes.MindMapCloud;
import java.awt.IllegalComponentStateException;
import java.awt.LayoutManager;
import java.awt.Container;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.NoSuchElementException;
import javax.swing.JLabel;


public class MindMapLayout implements java.awt.LayoutManager
{

    private static final int BORDER = 30;

    public static final int MINIMAL_LEAF_WIDTH = 150;

    public static final int MINIMAL_WIDTH = 50;

    private freemind.view.mindmapview.MapView map;

    private int ySize;

    private int xSize;

    private int rootX = 0;

    private int rootY = 0;

    public MindMapLayout( freemind.view.mindmapview.MapView map )
    {
        this.map = map;
    }

    public void addLayoutComponent( java.lang.String name, java.awt.Component comp )
    {
    }

    public void removeLayoutComponent( java.awt.Component comp )
    {
    }

    public void layoutContainer( java.awt.Container parent )
    {
        layout( true );
    }

    public void layout( boolean holdSelected )
    {
        freemind.view.mindmapview.NodeView selected = map.getSelected();
        holdSelected = holdSelected && (selected != null && selected.getX() != 0 && selected.getY() != 0);
        int oldRootX = getRoot().getX();
        int oldRootY = holdSelected ? selected.getY() : getRoot().getY();
        resizeMap( getRoot().getTreeWidth(), getRoot().getTreeHeight() );
        layout( map.getRoot() );
        try {
            int rootX = getRoot().getX();
            int rootY = holdSelected ? selected.getY() : getRoot().getY();
            getMapView().scrollBy( rootX - oldRootX, rootY - oldRootY, true );
        } catch ( java.awt.IllegalComponentStateException e ) {
        }
    }

    private void layout( freemind.view.mindmapview.NodeView node )
    {
        int x = 0;
        int hgap = node.getHGap();
        if (node.isRoot()) {
            x = 0;
        } else {
            if (node.isLeft()) {
                x = -hgap - node.getPreferredSize().width;
            } else {
                x = node.getParentView().getPreferredSize().width + hgap;
            }
        }
        placeNode( node, x, node.relYPos );
        for (java.util.ListIterator e = node.getChildrenViews().listIterator(); e.hasNext();) {
            layout( (freemind.view.mindmapview.NodeView) e.next() );
        }
    }

    private void placeNode( freemind.view.mindmapview.NodeView node, int relativeX, int relativeY )
    {
        if (node.isRoot()) {
            node.setBounds( getRootX(), getRootY() );
        } else {
            int x = node.getParentView().getX() + relativeX;
            int y = node.getParentView().getY() + relativeY;
            node.setBounds( x, y );
            javax.swing.JLabel label = node.getEdge().getLabel();
            java.awt.Point end = node.getInPoint();
            java.awt.Point start = node.getParentView().getOutPoint( end, node.isLeft() );
            node.getEdge().start = start;
            node.getEdge().end = end;
            int relX = (start.x - end.x) / 2;
            int absX = start.x - relX;
            int relY = (start.y - end.y) / 2;
            int absY = start.y - relY;
            label.setBounds( absX - label.getPreferredSize().width / 2, absY - label.getPreferredSize().height / 2, label.getPreferredSize().width, label.getPreferredSize().height );
        }
    }

    private int getRootY()
    {
        return calcYBorderSize() / 2 + getRoot().getUpperChildShift();
    }

    private int getRootX()
    {
        return calcXBorderSize() / 2 + getRoot().getLeftTreeWidth();
    }

    private void resizeMap( int width, int height )
    {
        boolean bResized = false;
        int oldXSize = getXSize();
        int oldYSize = getYSize();
        int minXSize = width + calcXBorderSize();
        int minYSize = height + calcYBorderSize();
        if (minXSize != getXSize()) {
            setXSize( minXSize );
            bResized = true;
        }
        if (minYSize != getYSize()) {
            setYSize( minYSize );
            bResized = true;
        }
        if (bResized) {
            getMapView().setSize( getXSize(), getYSize() );
        }
    }

    private int calcYBorderSize()
    {
        int yBorderSize;
        {
            java.awt.Dimension visibleSize = map.getViewportSize();
            if (visibleSize != null) {
                yBorderSize = 2 * Math.max( visibleSize.height, BORDER );
            } else {
                yBorderSize = 2 * BORDER;
            }
        }
        return yBorderSize;
    }

    private int calcXBorderSize()
    {
        int xBorderSize;
        {
            java.awt.Dimension visibleSize = map.getViewportSize();
            if (visibleSize != null) {
                xBorderSize = Math.max( visibleSize.width, 2 * (BORDER + MINIMAL_LEAF_WIDTH) );
            } else {
                xBorderSize = 2 * (BORDER + MINIMAL_LEAF_WIDTH);
            }
        }
        return xBorderSize;
    }

    void updateTreeHeightsAndRelativeYOfDescendantsAndAncestors( freemind.view.mindmapview.NodeView node )
    {
        updateTreeHeightsAndRelativeYOfDescendants( node );
        if (!node.isRoot()) {
            updateTreeHeightsAndRelativeYOfAncestors( node.getParentView() );
        }
    }

    void updateTreeHeightsAndRelativeYOfAncestors( freemind.view.mindmapview.NodeView node )
    {
        updateTreeGeometry( node );
        if (!node.isRoot()) {
            updateTreeHeightsAndRelativeYOfAncestors( node.getParentView() );
        }
    }

    void updateTreeHeightsAndRelativeYOfWholeMap()
    {
        updateTreeHeightsAndRelativeYOfDescendants( getRoot() );
        layout( false );
    }

    void updateTreeHeightsAndRelativeYOfDescendants( freemind.view.mindmapview.NodeView node )
    {
        for (java.util.ListIterator e = node.getChildrenViews().listIterator(); e.hasNext();) {
            updateTreeHeightsAndRelativeYOfDescendants( (freemind.view.mindmapview.NodeView) e.next() );
        }
        updateTreeGeometry( node );
    }

    private void updateRelativeYOfChildren( freemind.view.mindmapview.NodeView node, java.util.LinkedList childrenViews )
    {
        java.util.ListIterator e = childrenViews.listIterator();
        if (!e.hasNext()) {
            return;
        }
        int vgap = node.getVGap();
        freemind.view.mindmapview.NodeView child = (freemind.view.mindmapview.NodeView) childrenViews.getFirst();
        int pointer = 0;
        int upperShift = 0;
        while (e.hasNext()) {
            child = (freemind.view.mindmapview.NodeView) e.next();
            int shiftUp = getShiftUp( child );
            int shiftDown = getShiftDown( child );
            int iAdditionalCloudHeigth = child.getAdditionalCloudHeigth();
            int upperChildShift = child.getUpperChildShift();
            child.relYPos = pointer + upperChildShift-- + iAdditionalCloudHeigth / 2 + shiftDown;
            upperShift += upperChildShift + shiftUp;
            pointer += child.getTreeHeight() + shiftUp + shiftDown + iAdditionalCloudHeigth + vgap;
        }
        upperShift += calcStandardTreeShift( node, childrenViews );
        while (e.hasPrevious()) {
            child = (freemind.view.mindmapview.NodeView) e.previous();
            child.relYPos -= upperShift;
        }
    }

    protected int getShiftUp( freemind.view.mindmapview.NodeView node )
    {
        int shift = node.getShift();
        if (shift < 0) {
            return -shift;
        } else {
            return 0;
        }
    }

    protected int getShiftDown( freemind.view.mindmapview.NodeView node )
    {
        int shift = node.getShift();
        if (shift > 0) {
            return shift;
        } else {
            return 0;
        }
    }

    protected void updateTreeGeometry( freemind.view.mindmapview.NodeView node )
    {
        if (node.isRoot()) {
            java.util.LinkedList leftNodeViews = getRoot().getLeft();
            java.util.LinkedList rightNodeViews = getRoot().getRight();
            int leftWidth = calcTreeWidth( node, leftNodeViews );
            int rightWidth = calcTreeWidth( node, rightNodeViews );
            getRoot().setRootTreeWidths( leftWidth, rightWidth );
            updateRelativeYOfChildren( node, leftNodeViews );
            updateRelativeYOfChildren( node, rightNodeViews );
            int leftTreeShift = calcUpperChildShift( node, leftNodeViews );
            int rightTreeShift = calcUpperChildShift( node, rightNodeViews );
            getRoot().setRootUpperChildShift( leftTreeShift, rightTreeShift );
            int leftTreeHeight = calcTreeHeight( node, leftTreeShift, leftNodeViews );
            int rightTreeHeight = calcTreeHeight( node, rightTreeShift, rightNodeViews );
            getRoot().setRootTreeHeights( leftTreeHeight, rightTreeHeight );
        } else {
            java.util.LinkedList childrenViews = node.getChildrenViews();
            int treeWidth = calcTreeWidth( node, childrenViews );
            node.setTreeWidth( treeWidth );
            updateRelativeYOfChildren( node, childrenViews );
            int treeShift = calcUpperChildShift( node, childrenViews );
            node.setUpperChildShift( treeShift );
            int treeHeight = calcTreeHeight( node, treeShift, childrenViews );
            node.setTreeHeight( treeHeight );
        }
    }

    private int calcUpperChildShift( freemind.view.mindmapview.NodeView node, java.util.LinkedList childrenViews )
    {
        try {
            freemind.view.mindmapview.NodeView firstChild = (freemind.view.mindmapview.NodeView) childrenViews.getFirst();
            int childShift = -firstChild.relYPos + firstChild.getAdditionalCloudHeigth() / 2 + firstChild.getUpperChildShift();
            return childShift > 0 ? childShift : 0;
        } catch ( java.util.NoSuchElementException e ) {
            return 0;
        }
    }

    private int calcStandardTreeShift( freemind.view.mindmapview.NodeView parent, java.util.LinkedList childrenViews )
    {
        int parentHeight = parent.getPreferredSize().height;
        if (childrenViews == null || childrenViews.size() == 0) {
            return 0;
        }
        int height = 0;
        int vgap = parent.getVGap();
        for (java.util.ListIterator e = childrenViews.listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView node = (freemind.view.mindmapview.NodeView) e.next();
            if (node != null) {
                height += node.getPreferredSize().height + vgap + node.getAdditionalCloudHeigth();
            }
        }
        return Math.max( height - vgap - parentHeight, 0 ) / 2;
    }

    private int calcTreeHeight( freemind.view.mindmapview.NodeView parent, int treeShift, java.util.LinkedList childrenViews )
    {
        int parentHeight = parent.getPreferredSize().height;
        try {
            freemind.view.mindmapview.NodeView firstChild = (freemind.view.mindmapview.NodeView) childrenViews.getFirst();
            freemind.view.mindmapview.NodeView lastChild = (freemind.view.mindmapview.NodeView) childrenViews.getLast();
            int minY = Math.min( firstChild.relYPos - firstChild.getUpperChildShift() - firstChild.getAdditionalCloudHeigth() / 2, 0 );
            int maxY = Math.max( lastChild.relYPos - lastChild.getUpperChildShift() + lastChild.getTreeHeight() + lastChild.getAdditionalCloudHeigth() / 2, parentHeight );
            return maxY - minY;
        } catch ( java.util.NoSuchElementException e ) {
            return parentHeight;
        }
    }

    private int calcTreeWidth( freemind.view.mindmapview.NodeView parent, java.util.LinkedList childrenViews )
    {
        int treeWidth = 0;
        for (java.util.ListIterator e = childrenViews.listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView childNode = (freemind.view.mindmapview.NodeView) e.next();
            if (childNode != null) {
                int childWidth = childNode.getTreeWidth() + childNode.getHGap();
                if (childWidth > treeWidth) {
                    treeWidth = childWidth;
                }
            }
        }
        return parent.getPreferredSize().width + 2 * parent.getAdditionalCloudHeigth() + treeWidth;
    }

    private freemind.view.mindmapview.RootNodeView getRoot()
    {
        return (freemind.view.mindmapview.RootNodeView) map.getRoot();
    }

    private freemind.view.mindmapview.MapView getMapView()
    {
        return map;
    }

    private freemind.main.FreeMindMain getFrame()
    {
        return map.getController().getFrame();
    }

    public java.awt.Dimension minimumLayoutSize( java.awt.Container parent )
    {
        return new java.awt.Dimension( 200, 200 );
    }

    public java.awt.Dimension preferredLayoutSize( java.awt.Container parent )
    {
        return new java.awt.Dimension( getXSize(), getYSize() );
    }

    private int getXSize()
    {
        return xSize;
    }

    private int getYSize()
    {
        return ySize;
    }

    private void setXSize( int i )
    {
        xSize = i;
    }

    private void setYSize( int i )
    {
        ySize = i;
    }

}
