// This is mutant program.
// Author : ysma

package freemind.modes.mindmapmode;


import java.awt.Color;
import java.awt.EventQueue;
import java.awt.datatransfer.Transferable;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.Writer;
import java.lang.reflect.InvocationTargetException;
import java.net.URL;
import java.nio.channels.FileLock;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import freemind.controller.MindMapNodesSelection;
import freemind.main.FreeMind;
import freemind.main.FreeMindMain;
import freemind.main.Tools;
import freemind.main.XMLParseException;
import freemind.modes.LinkRegistryAdapter;
import freemind.modes.MapAdapter;
import freemind.modes.MindMapLinkRegistry;
import freemind.modes.MindMapNode;


public class MindMapMapModel extends freemind.modes.MapAdapter
{

    freemind.modes.mindmapmode.MindMapMapModel.LockManager lockManager;

    private freemind.modes.LinkRegistryAdapter linkRegistry;

    private java.util.Timer timerForAutomaticSaving;

    public MindMapMapModel( freemind.main.FreeMindMain frame )
    {
        this( new freemind.modes.mindmapmode.MindMapNodeModel( frame.getResourceString( "new_mindmap" ), frame ), frame );
    }

    public MindMapMapModel( freemind.modes.mindmapmode.MindMapNodeModel root, freemind.main.FreeMindMain frame )
    {
        super( frame );
        lockManager = frame.getProperty( "experimental_file_locking_on" ).equals( "true" ) ? new freemind.modes.mindmapmode.MindMapMapModel.LockManager() : new freemind.modes.mindmapmode.MindMapMapModel.DummyLockManager();
        linkRegistry = new freemind.modes.LinkRegistryAdapter();
        setRoot( root );
        readOnly = false;
        timerForAutomaticSaving = new java.util.Timer();
        int delay = Integer.parseInt( getFrame().getProperty( "time_for_automatic_save" ) );
        int numberOfTempFiles = Integer.parseInt( getFrame().getProperty( "number_of_different_files_for_automatic_save" ) );
        boolean filesShouldBeDeletedAfterShutdown = Tools.safeEquals( getFrame().getProperty( "delete_automatic_saves_at_exit" ), "true" );
        java.lang.String path = getFrame().getProperty( "path_to_automatic_saves" );
        if (Tools.safeEquals( path, "default" )) {
            path = null;
        }
        if (Tools.safeEquals( path, "freemind_home" )) {
            path = getFrame().getFreemindDirectory();
        }
        java.io.File dirToStore = null;
        if (path != null) {
            dirToStore = new java.io.File( path );
            if (!dirToStore.isDirectory()) {
                dirToStore = null;
                System.err.println( "Temporary directory " + path + " not found. Disabling automatic store." );
                delay = Integer.MAX_VALUE;
            }
        }
        timerForAutomaticSaving.schedule( new freemind.modes.mindmapmode.MindMapMapModel.doAutomaticSave( this, numberOfTempFiles, filesShouldBeDeletedAfterShutdown, dirToStore ), delay, delay );
    }

    public freemind.modes.MindMapLinkRegistry getLinkRegistry()
    {
        return linkRegistry;
    }

    public java.lang.String getRestoreable()
    {
        return getFile() == null ? null : "MindMap:" + getFile().getAbsolutePath();
    }

    public java.lang.String toString()
    {
        return getFile() == null ? null : getFile().getName();
    }

    public boolean saveHTML( freemind.modes.mindmapmode.MindMapNodeModel rootNodeOfBranch, java.io.File file )
    {
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            java.lang.String el = System.getProperty( "line.separator" );
            fileout.write( "<html>" + el + "<head>" + el + "<title>" + rootNodeOfBranch.saveHTML_escapeUnicodeAndSpecialCharacters( rootNodeOfBranch.toString() ) + "</title>" + el + "<style type=\"text/css\">" + el + "    span.foldopened { color: white; font-size: xx-small;" + el + "    border-width: 1; font-family: monospace; padding: 0em 0.25em 0em 0.25em; background: #e0e0e0;" + el + "    VISIBILITY: visible;" + el + "    cursor:pointer; }" + el + "" + el + "" + el + "    span.foldclosed { color: #666666; font-size: xx-small;" + el + "    border-width: 1; font-family: monospace; padding: 0em 0.25em 0em 0.25em; background: #e0e0e0;" + el + "    VISIBILITY: hidden;" + el + "    cursor:pointer; }" + el + "" + el + "    span.foldspecial { color: #666666; font-size: xx-small; border-style: none solid solid none;" + el + "    border-color: #CCCCCC; border-width: 1; font-family: sans-serif; padding: 0em 0.1em 0em 0.1em; background: #e0e0e0;" + el + "    cursor:pointer; }" + el + "" + el + "    li { list-style: none; }" + el + "" + el + "    span.l { color: red; font-weight: bold; }" + el + "" + el + "    a:link {text-decoration: none; color: black; }" + el + "    a:visited {text-decoration: none; color: black; }" + el + "    a:active {text-decoration: none; color: black; }" + el + "    a:hover {text-decoration: none; color: black; background: #eeeee0; }" + el + "" + el + "</style>" + el + "<!-- ^ Position is not set to relative / absolute here because of Mozilla -->" + el + "</head>" + el + "<body>" + el );
            java.lang.String htmlExportFoldingOption = getFrame().getProperty( "html_export_folding" );
            boolean writeFoldingCode = htmlExportFoldingOption.equals( "html_export_fold_currently_folded" ) && rootNodeOfBranch.hasFoldedStrictDescendant() || htmlExportFoldingOption.equals( "html_export_fold_all" );
            if (writeFoldingCode) {
                fileout.write( "" + el + "<script language=\"JavaScript\">" + el + "   // Here we implement folding. It works fine with MSIE5.5, MSIE6.0 and" + el + "   // Mozilla 0.9.6." + el + "" + el + "   if (document.layers) {" + el + "      //Netscape 4 specific code" + el + "      pre = 'document.';" + el + "      post = ''; }" + el + "   if (document.getElementById) {" + el + "      //Netscape 6 specific code" + el + "      pre = 'document.getElementById(\"';" + el + "      post = '\").style'; }" + el + "   if (document.all) {" + el + "      //IE4+ specific code" + el + "      pre = 'document.all.';" + el + "      post = '.style'; }" + el + "" + el + "function layer_exists(layer) {" + el + "   try {" + el + "      eval(pre + layer + post);" + el + "      return true; }" + el + "   catch (error) {" + el + "      return false; }}" + el + "" + el + "function show_layer(layer) {" + el + "   eval(pre + layer + post).position = 'relative'; " + el + "   eval(pre + layer + post).visibility = 'visible'; }" + el + "" + el + "function hide_layer(layer) {" + el + "   eval(pre + layer + post).visibility = 'hidden';" + el + "   eval(pre + layer + post).position = 'absolute'; }" + el + "" + el + "function hide_folder(folder) {" + el + "    hide_folding_layer(folder)" + el + "    show_layer('show'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "}" + el + "" + el + "function show_folder(folder) {" + el + "    // Precondition: all subfolders are folded" + el + "" + el + "    show_layer('hide'+folder);" + el + "    hide_layer('show'+folder);" + el + "    show_layer('fold'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "" + el + "    var i;" + el + "    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_layer('show'+folder+'_'+i); }" + el + "}" + el + "" + "function show_folder_completely(folder) {" + el + "    // Precondition: all subfolders are folded" + el + "" + el + "    show_layer('hide'+folder);" + el + "    hide_layer('show'+folder);" + el + "    show_layer('fold'+folder);" + el + "" + el + "    scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "" + el + "    var i;" + el + "    for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_folder_completely(folder+'_'+i); }" + el + "}" + el + "" + el + "" + el + "" + el + "function hide_folding_layer(folder) {" + el + "   var i;" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       hide_folding_layer(folder+'_'+i); }" + el + "" + el + "   hide_layer('hide'+folder);" + el + "   hide_layer('show'+folder);" + el + "   hide_layer('fold'+folder);" + el + "" + el + "   scrollBy(0,0); // This is a work around to make it work in Browsers (Explorer, Mozilla)" + el + "}" + el + "" + el + "function fold_document() {" + el + "   var i;" + el + "   var folder = '1';" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       hide_folder(folder+'_'+i); }" + el + "}" + el + "" + el + "function unfold_document() {" + el + "   var i;" + el + "   var folder = '1';" + el + "   for (i=1; layer_exists('fold'+folder+'_'+i); ++i) {" + el + "       show_folder_completely(folder+'_'+i); }" + el + "}" + el + "" + el + "</script>" + el );
                fileout.write( "<SPAN class=foldspecial onclick=\"fold_document()\">All +</SPAN>" + el );
                fileout.write( "<SPAN class=foldspecial onclick=\"unfold_document()\">All -</SPAN>" + el );
            }
            rootNodeOfBranch.saveHTML( fileout, "1", 0, true, true, 1 );
            if (writeFoldingCode) {
                fileout.write( "<SCRIPT language=JavaScript>" + el );
                fileout.write( "fold_document();" + el );
                fileout.write( "</SCRIPT>" + el );
            }
            fileout.write( "</body>" + el );
            fileout.write( "</html>" + el );
            fileout.close();
            return true;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.saveHTML(): " );
            e.printStackTrace();
            return false;
        }
    }

    public java.lang.String getAsPlainText( java.util.List mindMapNodes )
    {
        try {
            java.io.StringWriter stringWriter = new java.io.StringWriter();
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( stringWriter );
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).saveTXT( fileout, 0 );
            }
            fileout.close();
            return stringWriter.toString();
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return null;
        }
    }

    public boolean saveTXT( freemind.modes.mindmapmode.MindMapNodeModel rootNodeOfBranch, java.io.File file )
    {
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            rootNodeOfBranch.saveTXT( fileout, 0 );
            fileout.close();
            return true;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.saveTXT(): " );
            e.printStackTrace();
            return false;
        }
    }

    public java.lang.String getAsRTF( java.util.List mindMapNodes )
    {
        try {
            java.io.StringWriter stringWriter = new java.io.StringWriter();
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( stringWriter );
            saveRTF( mindMapNodes, fileout );
            fileout.close();
            return stringWriter.toString();
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return null;
        }
    }

    public boolean saveRTF( java.util.List mindMapNodes, java.io.BufferedWriter fileout )
    {
        try {
            java.util.HashSet colors = new java.util.HashSet();
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).collectColors( colors );
            }
            java.lang.String colorTableString = "{\\colortbl;\\red0\\green0\\blue255;";
            java.util.HashMap colorTable = new java.util.HashMap();
            int colorPosition = 2;
            for (java.util.Iterator it = colors.iterator(); it.hasNext(); ++colorPosition) {
                java.awt.Color color = (java.awt.Color) it.next();
                colorTableString += "\\red" + color.getRed() + "\\green" + color.getGreen() + "\\blue" + color.getBlue() + ";";
                colorTable.put( color, new java.lang.Integer( colorPosition ) );
            }
            colorTableString += "}";
            fileout.write( "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1033{\\fonttbl{\\f0\\fswiss\\fcharset0 Arial;}" + colorTableString + "}" + "\\viewkind4\\uc1\\pard\\f0\\fs20{}" );
            for (java.util.ListIterator it = mindMapNodes.listIterator(); it.hasNext();) {
                ((freemind.modes.mindmapmode.MindMapNodeModel) it.next()).saveRTF( fileout, 0, colorTable );
            }
            fileout.write( "}" );
            return true;
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return false;
        }
    }

    public boolean save( java.io.File file )
    {
        return saveInternal( file, false );
    }

    private boolean saveInternal( java.io.File file, boolean isInternal )
    {
        if (!isInternal && readOnly) {
            System.err.println( "Attempt to save read-only map." );
            return false;
        }
        try {
            java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( file ) ) );
            getXml( fileout );
            if (!isInternal) {
                setFile( file );
                setSaved( true );
            }
            return true;
        } catch ( java.io.FileNotFoundException e ) {
            java.lang.String message = Tools.expandPlaceholders( getText( "save_failed" ), file.getName() );
            if (!isInternal) {
                getFrame().getController().errorMessage( message );
            } else {
                getFrame().out( message );
            }
            return false;
        } catch ( java.lang.Exception e ) {
            System.err.println( "Error in MindMapMapModel.save(): " );
            e.printStackTrace();
            return false;
        }
    }

    public void getXml( java.io.Writer fileout )
        throws java.io.IOException
    {
        fileout.write( "<map version=\"" + getFrame().getFreemindVersion() + "\">\n" );
        fileout.write( "<!-- To view this file, download free mind mapping software FreeMind from http://freemind.sourceforge.net -->\n" );
        ((freemind.modes.mindmapmode.MindMapNodeModel) getRoot()).save( fileout, this.getLinkRegistry() );
        fileout.write( "</map>\n" );
        fileout.close();
    }

    public java.lang.String tryToLock( java.io.File file )
        throws java.lang.Exception
    {
        java.lang.String lockingUser = lockManager.tryToLock( file );
        java.lang.String lockingUserOfOldLock = lockManager.popLockingUserOfOldLock();
        if (lockingUserOfOldLock != null) {
            getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "locking_old_lock_removed" ), file.getName(), lockingUserOfOldLock ) );
        }
        if (lockingUser == null) {
            readOnly = false;
        }
        return lockingUser;
    }

    public void load( java.io.File file )
        throws java.io.FileNotFoundException, java.io.IOException, freemind.main.XMLParseException
    {
        if (!file.exists()) {
            throw new java.io.FileNotFoundException( Tools.expandPlaceholders( getText( "file_not_found" ), file.getPath() ) );
        }
        if (!file.canWrite()) {
            readOnly = true;
        } else {
            try {
                java.lang.String lockingUser = tryToLock( file );
                if (lockingUser != null) {
                    getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "map_locked_by_open" ), file.getName(), lockingUser ) );
                    readOnly = true;
                } else {
                    readOnly = false;
                }
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
                getFrame().getController().informationMessage( Tools.expandPlaceholders( getText( "locking_failed_by_open" ), file.getName() ) );
                readOnly = true;
            }
        }
        freemind.modes.mindmapmode.MindMapNodeModel root = loadTree( file );
        if (root != null) {
            setRoot( root );
        }
        setFile( file );
        setSaved( true );
    }

    public void destroy()
    {
        super.destroy();
        lockManager.releaseLock();
        lockManager.releaseTimer();
        timerForAutomaticSaving.cancel();
    }

    freemind.modes.mindmapmode.MindMapNodeModel loadTree( java.io.File file )
        throws freemind.main.XMLParseException, java.io.IOException
    {
        freemind.modes.mindmapmode.MindMapXMLElement mapElement = new freemind.modes.mindmapmode.MindMapXMLElement( getFrame() );
        java.lang.String expectedStartString = "<map version=\"" + FreeMind.version + "\"";
        java.lang.String expectedAlternativeStartString = "<map version=\"0.7.1\"";
        int versionInfoLength = expectedStartString.length();
        java.lang.StringBuffer buffer = readFileStart( file, versionInfoLength );
        java.lang.String mapStart = "";
        if (buffer.length() >= versionInfoLength) {
            mapStart = buffer.substring( 0, versionInfoLength );
        }
        java.io.Reader reader = null;
        if (mapStart.equals( expectedStartString ) || mapStart.equals( expectedAlternativeStartString )) {
            reader = getActualReader( file );
        } else {
            reader = getUpdateReader( file );
        }
        try {
            mapElement.parseFromReader( reader );
        } catch ( java.lang.Exception ex ) {
            System.err.println( "Error while parsing file:" + ex );
            ex.printStackTrace();
            return null;
        } finally 
{
            if (reader != null) {
                reader.close();
            }
        }
        mapElement.processUnfinishedLinks( getLinkRegistry() );
        return (freemind.modes.mindmapmode.MindMapNodeModel) mapElement.getMapChild();
    }

    private java.lang.StringBuffer readFileStart( java.io.File file, int pMinimumLength )
    {
        java.io.BufferedReader in = null;
        java.lang.StringBuffer buffer = new java.lang.StringBuffer();
        try {
            in = new java.io.BufferedReader( new java.io.FileReader( file ) );
            java.lang.String str;
            while ((str = in.readLine()) != null) {
                buffer.append( str );
                if (buffer.length() >= pMinimumLength) {
                    break;
                }
            }
            in.close();
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
            return new java.lang.StringBuffer();
        }
        return buffer;
    }

    private java.io.Reader getUpdateReader( java.io.File file )
        throws java.io.IOException
    {
        java.io.StringWriter writer = null;
        java.io.InputStream inputStream = null;
        logger.info( "Updating the file " + file.getName() + " to the current version." );
        try {
            java.net.URL updaterUrl = null;
            updaterUrl = getFrame().getResource( "freemind/modes/mindmapmode/freemind_version_updater.xslt" );
            if (updaterUrl == null) {
                throw new java.lang.IllegalArgumentException( "freemind_version_updater.xslt not found." );
            }
            javax.xml.transform.Source xsltSource = null;
            inputStream = updaterUrl.openStream();
            xsltSource = new javax.xml.transform.stream.StreamSource( inputStream );
            writer = new java.io.StringWriter();
            javax.xml.transform.Result result = new javax.xml.transform.stream.StreamResult( writer );
            javax.xml.transform.TransformerFactory transFact = TransformerFactory.newInstance();
            javax.xml.transform.Transformer trans = transFact.newTransformer( xsltSource );
            trans.transform( new javax.xml.transform.stream.StreamSource( file ), result );
            logger.info( "Updating the file " + file.getName() + " to the current version. Done." );
        } catch ( java.lang.Exception ex ) {
            ex.printStackTrace();
            return getActualReader( file );
        } finally 
{
            if (inputStream != null) {
                inputStream.close();
            }
            if (writer != null) {
                writer.close();
            }
        }
        return new java.io.StringReader( writer.getBuffer().toString() );
    }

    private java.io.Reader getActualReader( java.io.File file )
        throws java.io.FileNotFoundException
    {
        return new java.io.BufferedReader( new java.io.FileReader( file ) );
    }

    public java.awt.datatransfer.Transferable copy( freemind.modes.MindMapNode node )
    {
        java.io.StringWriter stringWriter = new java.io.StringWriter();
        try {
            ((freemind.modes.mindmapmode.MindMapNodeModel) node).save( stringWriter, this.getLinkRegistry() );
        } catch ( java.io.IOException e ) {
        }
        return new freemind.controller.MindMapNodesSelection( stringWriter.toString(), null, null, null, null, null );
    }

    private class LockManager extends java.util.TimerTask
    {

        java.io.File lockedSemaphoreFile = null;

        java.util.Timer lockTimer = null;

        final long lockUpdatePeriod = 4 * 60 * 1000;

        final long lockSafetyPeriod = 5 * 60 * 1000;

        java.lang.String lockingUserOfOldLock = null;

        private java.io.File getSemaphoreFile( java.io.File mapFile )
        {
            return new java.io.File( mapFile.getParent() + System.getProperty( "file.separator" ) + "$~" + mapFile.getName() + "~" );
        }

        public synchronized java.lang.String popLockingUserOfOldLock()
        {
            java.lang.String toReturn = lockingUserOfOldLock;
            lockingUserOfOldLock = null;
            return toReturn;
        }

        private void writeSemaphoreFile( java.io.File inSemaphoreFile )
                throws java.lang.Exception
        {
            java.io.FileOutputStream semaphoreOutputStream = new java.io.FileOutputStream( inSemaphoreFile );
            java.nio.channels.FileLock lock = null;
            try {
                lock = semaphoreOutputStream.getChannel().tryLock();
                if (lock == null) {
                    semaphoreOutputStream.close();
                    System.err.println( "Locking failed." );
                    throw new java.lang.Exception();
                }
            } catch ( java.lang.UnsatisfiedLinkError eUle ) {
            } catch ( java.lang.NoClassDefFoundError eDcdf ) {
            }
            semaphoreOutputStream.write( System.getProperty( "user.name" ).getBytes() );
            semaphoreOutputStream.write( '\n' );
            semaphoreOutputStream.write( String.valueOf( System.currentTimeMillis() ).getBytes() );
            semaphoreOutputStream.close();
            semaphoreOutputStream = null;
            Tools.setHidden( inSemaphoreFile, true, false );
            if (lock != null) {
                lock.release();
            }
        }

        public synchronized java.lang.String tryToLock( java.io.File file )
                throws java.lang.Exception
        {
            java.io.File semaphoreFile = getSemaphoreFile( file );
            if (semaphoreFile == lockedSemaphoreFile) {
                return null;
            }
            try {
                java.io.BufferedReader semaphoreReader = new java.io.BufferedReader( new java.io.FileReader( semaphoreFile ) );
                java.lang.String lockingUser = semaphoreReader.readLine();
                long lockTime = (new java.lang.Long( semaphoreReader.readLine() )).longValue();
                long timeDifference = System.currentTimeMillis() - lockTime;
                if (timeDifference > lockSafetyPeriod) {
                    semaphoreReader.close();
                    lockingUserOfOldLock = lockingUser;
                    semaphoreFile.delete();
                } else {
                    return lockingUser;
                }
            } catch ( java.io.FileNotFoundException e ) {
            }
            writeSemaphoreFile( semaphoreFile );
            if (lockTimer == null) {
                lockTimer = new java.util.Timer();
                lockTimer.schedule( this, lockUpdatePeriod, lockUpdatePeriod );
            }
            releaseLock();
            lockedSemaphoreFile = semaphoreFile;
            return null;
        }

        public synchronized void releaseLock()
        {
            if (lockedSemaphoreFile != null) {
                lockedSemaphoreFile.delete();
                lockedSemaphoreFile = null;
            }
        }

        public synchronized void releaseTimer()
        {
            if (lockTimer != null) {
                lockTimer.cancel();
                lockTimer = null;
            }
        }

        public synchronized void run()
        {
            if (lockedSemaphoreFile == null) {
                System.err.println( "unexpected: lockedSemaphoreFile is null upon lock update" );
                return;
            }
            try {
                Tools.setHidden( lockedSemaphoreFile, false, true );
                writeSemaphoreFile( lockedSemaphoreFile );
            } catch ( java.lang.Exception e ) {
                e.printStackTrace();
            }
        }

    }

    private class DummyLockManager extends freemind.modes.mindmapmode.MindMapMapModel.LockManager
    {

        public synchronized java.lang.String popLockingUserOfOldLock()
        {
            return null;
        }

        public synchronized java.lang.String tryToLock( java.io.File file )
                throws java.lang.Exception
        {
            return null;
        }

        public synchronized void releaseLock()
        {
        }

        public synchronized void releaseTimer()
        {
        }

        public synchronized void run()
        {
        }

    }

    private class doAutomaticSave extends java.util.TimerTask
    {

        private freemind.modes.mindmapmode.MindMapMapModel model;

        private java.util.Vector tempFileStack;

        private int numberOfFiles;

        private boolean filesShouldBeDeletedAfterShutdown;

        private java.io.File pathToStore;

        private int changeState;

        doAutomaticSave( freemind.modes.mindmapmode.MindMapMapModel model, int numberOfTempFiles, boolean filesShouldBeDeletedAfterShutdown, java.io.File pathToStore )
        {
            this.model = model;
            tempFileStack = new java.util.Vector();
            numberOfFiles = numberOfTempFiles > 0 ? numberOfTempFiles : 1;
            this.filesShouldBeDeletedAfterShutdown = filesShouldBeDeletedAfterShutdown;
            this.pathToStore = pathToStore;
            changeState = 0;
        }

        public void run()
        {
            if (model.getNumberOfChangesSinceLastSave() == changeState) {
                return;
            }
            changeState = model.getNumberOfChangesSinceLastSave();
            if (model.getNumberOfChangesSinceLastSave() == 0) {
                return;
            }
            try {
                EventQueue.invokeAndWait( new java.lang.Runnable(){
                    public void run()
                    {
                        java.io.File tempFile;
                        if (tempFileStack.size() != numberOfFiles) {
                            tempFile = (java.io.File) tempFileStack.remove( 0 );
                        } else {
                            try {
                                tempFile = File.createTempFile( "FM_" + (model.toString() == null ? "unnamed" : model.toString()), ".mm", pathToStore );
                                if (filesShouldBeDeletedAfterShutdown) {
                                    tempFile.deleteOnExit();
                                }
                            } catch ( java.lang.Exception e ) {
                                System.err.println( "Error in automatic MindMapMapModel.save(): " + e.getMessage() );
                                e.printStackTrace();
                                return;
                            }
                        }
                        try {
                            model.saveInternal( tempFile, true );
                            model.getFrame().out( "Map was automatically saved (using the file name " + tempFile + ") ..." );
                        } catch ( java.lang.Exception e ) {
                            System.err.println( "Error in automatic MindMapMapModel.save(): " + e.getMessage() );
                            e.printStackTrace();
                        }
                        tempFileStack.add( tempFile );
                    }
                } );
            } catch ( java.lang.InterruptedException e ) {
                e.printStackTrace();
            } catch ( java.lang.reflect.InvocationTargetException e ) {
                e.printStackTrace();
            }
        }

    }

}
