// This is mutant program.
// Author : ysma

package freemind.preferences.layout;


import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;
import javax.xml.bind.JAXBException;
import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.factories.ButtonBarFactory;
import com.jgoodies.forms.layout.FormLayout;
import freemind.controller.Controller;
import freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorage;
import freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorageType;
import freemind.controller.actions.generated.instance.WindowConfigurationStorage;
import freemind.main.FreeMind;
import freemind.main.FreeMindMain;
import freemind.main.Tools;
import freemind.modes.MindMapNode;


public class OptionPanel
{

    private static final java.awt.Color MARKED_BUTTON_COLOR = Color.BLUE;

    private java.util.Vector controls;

    private final javax.swing.JDialog frame;

    private java.util.HashMap tabButtonMap = new java.util.HashMap();

    private java.util.HashMap tabActionMap = new java.util.HashMap();

    private java.lang.String selectedPanel = null;

    private static javax.swing.JColorChooser colorChooser;

    private final freemind.preferences.layout.OptionPanel.OptionPanelFeedback feedback;

    private static freemind.main.FreeMindMain fmMain;

    private static final java.lang.String PREFERENCE_STORAGE_PROPERTY = "OptionPanel_Window_Properties";

    private static final java.lang.String DEFAULT_LAYOUT_FORMAT = "right:max(40dlu;p), 4dlu, 120dlu, 7dlu";

    public OptionPanel( freemind.main.FreeMindMain fm, javax.swing.JDialog frame, freemind.preferences.layout.OptionPanel.OptionPanelFeedback feedback )
    {
        super();
        if (fmMain == null) {
            fmMain = fm;
        }
        this.frame = frame;
        this.feedback = feedback;
        freemind.controller.actions.generated.instance.WindowConfigurationStorage storage = fm.getController().decorateDialog( frame, PREFERENCE_STORAGE_PROPERTY );
        if (storage == null) {
            frame.getRootPane().setPreferredSize( new java.awt.Dimension( 800, 600 ) );
        } else {
            if (storage instanceof freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorageType) {
                freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorageType oWindowSettings = (freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorageType) storage;
                selectedPanel = oWindowSettings.getPanel();
            }
        }
    }

    public interface OptionPanelFeedback
    {

        void writeProperties( java.util.Properties props );

    }

    public static java.util.Vector changeListeners = new java.util.Vector();

    private static java.util.Properties getProperties()
    {
        checkConnectionToFreeMindMain();
        return fmMain.getProperties();
    }

    public void setProperties( java.util.Properties properties )
    {
        for (java.util.Iterator i = controls.iterator(); i.hasNext();) {
            freemind.preferences.layout.OptionPanel.PropertyControl control = (freemind.preferences.layout.OptionPanel.PropertyControl) i.next();
            if (control instanceof freemind.preferences.layout.OptionPanel.PropertyBean) {
                freemind.preferences.layout.OptionPanel.PropertyBean bean = (freemind.preferences.layout.OptionPanel.PropertyBean) control;
                java.lang.String value = properties.getProperty( bean.getLabel() );
                bean.setValue( value );
            }
        }
    }

    private java.util.Properties getOptionProperties()
    {
        java.util.Properties p = new java.util.Properties();
        for (java.util.Iterator i = controls.iterator(); i.hasNext();) {
            freemind.preferences.layout.OptionPanel.PropertyControl control = (freemind.preferences.layout.OptionPanel.PropertyControl) i.next();
            if (control instanceof freemind.preferences.layout.OptionPanel.PropertyBean) {
                freemind.preferences.layout.OptionPanel.PropertyBean bean = (freemind.preferences.layout.OptionPanel.PropertyBean) control;
                p.setProperty( bean.getLabel(), bean.getValue() );
            }
        }
        return p;
    }

    public void buildPanel()
    {
        com.jgoodies.forms.layout.FormLayout leftLayout = new com.jgoodies.forms.layout.FormLayout( "80dlu", "" );
        com.jgoodies.forms.builder.DefaultFormBuilder leftBuilder = new com.jgoodies.forms.builder.DefaultFormBuilder( leftLayout );
        java.awt.CardLayout cardLayout = new java.awt.CardLayout();
        javax.swing.JPanel rightStack = new javax.swing.JPanel( cardLayout );
        com.jgoodies.forms.layout.FormLayout rightLayout = null;
        com.jgoodies.forms.builder.DefaultFormBuilder rightBuilder = null;
        java.lang.String lastTabName = null;
        controls = getControls();
        for (java.util.Iterator i = controls.iterator(); i.hasNext();) {
            freemind.preferences.layout.OptionPanel.PropertyControl control = (freemind.preferences.layout.OptionPanel.PropertyControl) i.next();
            if (control instanceof freemind.preferences.layout.OptionPanel.NewTabProperty) {
                freemind.preferences.layout.OptionPanel.NewTabProperty newTab = (freemind.preferences.layout.OptionPanel.NewTabProperty) control;
                if (rightBuilder != null) {
                    rightStack.add( rightBuilder.getPanel(), lastTabName );
                }
                rightLayout = new com.jgoodies.forms.layout.FormLayout( newTab.getDescription(), "" );
                rightBuilder = new com.jgoodies.forms.builder.DefaultFormBuilder( rightLayout );
                rightBuilder.setDefaultDialogBorder();
                lastTabName = newTab.getLabel();
                javax.swing.JButton tabButton = new javax.swing.JButton( getText( lastTabName ) );
                freemind.preferences.layout.OptionPanel.ChangeTabAction changeTabAction = new freemind.preferences.layout.OptionPanel.ChangeTabAction( cardLayout, rightStack, lastTabName );
                tabButton.addActionListener( changeTabAction );
                registerTabButton( tabButton, lastTabName, changeTabAction );
                leftBuilder.append( tabButton );
            } else {
                control.layout( rightBuilder );
            }
        }
        rightStack.add( rightBuilder.getPanel(), lastTabName );
        if (selectedPanel != null && tabActionMap.containsKey( selectedPanel )) {
            ((freemind.preferences.layout.OptionPanel.ChangeTabAction) tabActionMap.get( selectedPanel )).actionPerformed( null );
        }
        javax.swing.JSplitPane centralPanel = new javax.swing.JSplitPane( JSplitPane.HORIZONTAL_SPLIT, leftBuilder.getPanel(), new javax.swing.JScrollPane( rightStack ) );
        frame.getContentPane().add( centralPanel, BorderLayout.CENTER );
        javax.swing.JButton cancelButton = new javax.swing.JButton( getText( "Cancel" ) );
        cancelButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed( java.awt.event.ActionEvent arg0 )
            {
                closeWindow();
            }
        } );
        javax.swing.JButton okButton = new javax.swing.JButton( getText( "OK" ) );
        okButton.addActionListener( new java.awt.event.ActionListener(){
            public void actionPerformed( java.awt.event.ActionEvent arg0 )
            {
                feedback.writeProperties( getOptionProperties() );
                closeWindow();
            }
        } );
        frame.getRootPane().setDefaultButton( okButton );
        frame.getContentPane().add( ButtonBarFactory.buildOKCancelBar( cancelButton, okButton ), BorderLayout.SOUTH );
    }

    private static java.lang.String lastKey = "";

    private static java.lang.String getText( java.lang.String string )
    {
        if (string == null) {
            return null;
        }
        checkConnectionToFreeMindMain();
        return fmMain.getResourceString( "OptionPanel." + string );
    }

    private static void checkConnectionToFreeMindMain()
    {
        if (fmMain == null) {
            throw new java.lang.IllegalArgumentException( "FreeMindMain not set yet." );
        }
    }

    private void registerTabButton( javax.swing.JButton tabButton, java.lang.String name, freemind.preferences.layout.OptionPanel.ChangeTabAction changeTabAction )
    {
        tabButtonMap.put( name, tabButton );
        tabActionMap.put( name, changeTabAction );
        if (selectedPanel == null) {
            selectedPanel = name;
        }
    }

    private javax.swing.JButton getTabButton( java.lang.String name )
    {
        return (javax.swing.JButton) tabButtonMap.get( name );
    }

    private java.util.Collection getAllButtons()
    {
        return tabButtonMap.values();
    }

    private final class ChangeTabAction implements java.awt.event.ActionListener
    {

        private java.awt.CardLayout cardLayout;

        private javax.swing.JPanel centralPanel;

        private java.lang.String tabName;

        private ChangeTabAction( java.awt.CardLayout cardLayout, javax.swing.JPanel centralPanel, java.lang.String tabName )
        {
            super();
            this.cardLayout = cardLayout;
            this.centralPanel = centralPanel;
            this.tabName = tabName;
        }

        public void actionPerformed( java.awt.event.ActionEvent arg0 )
        {
            cardLayout.show( centralPanel, tabName );
            java.util.Collection c = getAllButtons();
            for (java.util.Iterator i = c.iterator(); i.hasNext();) {
                javax.swing.JButton button = (javax.swing.JButton) i.next();
                button.setForeground( null );
            }
            getTabButton( tabName ).setForeground( MARKED_BUTTON_COLOR );
            selectedPanel = tabName;
        }

    }

    private interface PropertyControl
    {

        java.lang.String getDescription();

        java.lang.String getLabel();

        void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder );

    }

    private interface PropertyBean
    {

        java.lang.String getLabel();

        void setValue( java.lang.String value );

        java.lang.String getValue();

    }

    private static class SeparatorProperty implements freemind.preferences.layout.OptionPanel.PropertyControl
    {

        private java.lang.String label;

        public SeparatorProperty( java.lang.String label )
        {
            super();
            this.label = label;
        }

        public java.lang.String getDescription()
        {
            return null;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            builder.appendSeparator( getText( "separator." + getLabel() ) );
        }

    }

    private static class NewTabProperty implements freemind.preferences.layout.OptionPanel.PropertyControl
    {

        private java.lang.String label;

        private java.lang.String layoutFormat;

        public NewTabProperty( java.lang.String label )
        {
            this( label, DEFAULT_LAYOUT_FORMAT );
        }

        public NewTabProperty( java.lang.String label, java.lang.String layoutFormat )
        {
            super();
            this.label = label;
            this.layoutFormat = layoutFormat;
        }

        public java.lang.String getDescription()
        {
            return layoutFormat;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
        }

    }

    private static class NextLineProperty implements freemind.preferences.layout.OptionPanel.PropertyControl
    {

        public NextLineProperty()
        {
            super();
        }

        public java.lang.String getDescription()
        {
            return null;
        }

        public java.lang.String getLabel()
        {
            return null;
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            builder.nextLine();
        }

    }

    private static class StringProperty extends javax.swing.JTextField implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean
    {

        java.lang.String description;

        java.lang.String label;

        public StringProperty( java.lang.String description, java.lang.String label )
        {
            super();
            this.description = description;
            this.label = label;
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            setText( value );
        }

        public java.lang.String getValue()
        {
            return getText();
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), this );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
        }

    }

    private static class NumberProperty implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean
    {

        java.lang.String description;

        javax.swing.JSlider slider;

        java.lang.String label;

        private javax.swing.JSpinner spinner;

        public NumberProperty( java.lang.String description, java.lang.String label, int min, int max, int step )
        {
            slider = new javax.swing.JSlider( JSlider.HORIZONTAL, 5, 1000, 100 );
            spinner = new javax.swing.JSpinner( new javax.swing.SpinnerNumberModel( min, min, max, step ) );
            this.description = description;
            this.label = label;
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            int intValue = 100;
            try {
                intValue = Integer.parseInt( value );
            } catch ( java.lang.NumberFormatException e ) {
                e.printStackTrace();
            }
            spinner.setValue( new java.lang.Integer( intValue ) );
        }

        public java.lang.String getValue()
        {
            return spinner.getValue().toString();
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), spinner );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
        }

    }

    private static class ColorProperty extends javax.swing.JButton implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean, java.awt.event.ActionListener
    {

        java.lang.String description;

        java.lang.String label;

        java.awt.Color color;

        final javax.swing.JPopupMenu menu = new javax.swing.JPopupMenu();

        private final java.lang.String defaultColor;

        public ColorProperty( java.lang.String description, java.lang.String label, java.lang.String defaultColor )
        {
            super();
            this.description = description;
            this.label = label;
            this.defaultColor = defaultColor;
            addActionListener( this );
            color = Color.BLACK;
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            setColorValue( Tools.xmlToColor( value ) );
        }

        public java.lang.String getValue()
        {
            return Tools.colorToXml( getColorValue() );
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), this );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
            javax.swing.JMenuItem item = new javax.swing.JMenuItem( fmMain.getResourceString( "OptionPanel.ColorProperty.ResetColor" ) );
            item.addActionListener( new java.awt.event.ActionListener(){
                public void actionPerformed( java.awt.event.ActionEvent e )
                {
                    setValue( defaultColor );
                }
            } );
            menu.add( item );
            this.addMouseListener( new java.awt.event.MouseAdapter(){
                public void mousePressed( java.awt.event.MouseEvent evt )
                {
                    if (evt.isPopupTrigger()) {
                        menu.show( evt.getComponent(), evt.getX(), evt.getY() );
                    }
                }

                public void mouseReleased( java.awt.event.MouseEvent evt )
                {
                    if (evt.isPopupTrigger()) {
                        menu.show( evt.getComponent(), evt.getX(), evt.getY() );
                    }
                }
            } );
        }

        public void actionPerformed( java.awt.event.ActionEvent arg0 )
        {
            java.awt.Color result = Controller.showCommonJColorChooserDialog( getRootPane(), getLabel(), getColorValue() );
            if (result != null) {
                setColorValue( result );
            }
        }

        private void setColorValue( java.awt.Color result )
        {
            color = result;
            setBackground( result );
            setText( Tools.colorToXml( result ) );
        }

        private java.awt.Color getColorValue()
        {
            return color;
        }

    }

    private static class KeyProperty extends javax.swing.JButton implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean
    {

        java.lang.String description;

        java.lang.String label;

        public KeyProperty( final javax.swing.JDialog frame, java.lang.String description, java.lang.String label )
        {
            super();
            this.description = description;
            this.label = label;
            addActionListener( new java.awt.event.ActionListener(){
                public void actionPerformed( java.awt.event.ActionEvent arg0 )
                {
                    java.util.Vector allKeybindings = new java.util.Vector();
                    freemind.preferences.layout.GrabKeyDialog dialog = new freemind.preferences.layout.GrabKeyDialog( fmMain, frame, new freemind.preferences.layout.GrabKeyDialog.KeyBinding( getLabel(), getLabel(), getValue(), false ), allKeybindings, null );
                    if (dialog.isOK()) {
                        setValue( dialog.getShortcut() );
                    }
                }
            } );
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            setText( value );
            setToolTipText( getText() );
        }

        public java.lang.String getValue()
        {
            return getText();
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), this );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
        }

    }

    private static class BooleanProperty extends javax.swing.JCheckBox implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean
    {

        java.lang.String description;

        java.lang.String label;

        public BooleanProperty( java.lang.String description, java.lang.String label )
        {
            super();
            this.description = description;
            this.label = label;
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            if (value == null || !(value.toLowerCase().equals( "true" ) || value.toLowerCase().equals( "false" ))) {
                throw new java.lang.IllegalArgumentException( "Cannot set a boolean to " + value );
            }
            setVerifyInputWhenFocusTarget( value.toLowerCase().equals( "true" ) );
        }

        public java.lang.String getValue()
        {
            return isSelected() ? "true" : "false";
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), this );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
        }

    }

    private static class ComboProperty extends javax.swing.JComboBox implements freemind.preferences.layout.OptionPanel.PropertyControl, freemind.preferences.layout.OptionPanel.PropertyBean
    {

        java.lang.String description;

        java.lang.String label;

        private java.util.Vector possibleValues;

        public ComboProperty( java.lang.String description, java.lang.String label, java.lang.String[] possibles )
        {
            super();
            this.description = description;
            this.label = label;
            fillPossibleValues( possibles );
            java.util.Vector possibleTranslations = new java.util.Vector();
            for (java.util.Iterator i = possibleValues.iterator(); i.hasNext();) {
                java.lang.String key = (java.lang.String) i.next();
                possibleTranslations.add( OptionPanel.getText( key ) );
            }
            setModel( new javax.swing.DefaultComboBoxModel( possibleTranslations ) );
        }

        public ComboProperty( java.lang.String description, java.lang.String label, java.lang.String[] possibles, java.util.Vector possibleTranslations )
        {
            this.description = description;
            this.label = label;
            fillPossibleValues( possibles );
            setModel( new javax.swing.DefaultComboBoxModel( possibleTranslations ) );
        }

        private void fillPossibleValues( java.lang.String[] possibles )
        {
            this.possibleValues = new java.util.Vector();
            possibleValues.addAll( Arrays.asList( possibles ) );
        }

        public java.lang.String getDescription()
        {
            return description;
        }

        public java.lang.String getLabel()
        {
            return label;
        }

        public void setValue( java.lang.String value )
        {
            if (possibleValues.contains( value )) {
                super.setSelectedIndex( possibleValues.indexOf( value ) );
            } else {
                throw new java.lang.IllegalArgumentException( "Unknown value:" + value );
            }
        }

        public java.lang.String getValue()
        {
            return (java.lang.String) possibleValues.get( super.getSelectedIndex() );
        }

        public void layout( com.jgoodies.forms.builder.DefaultFormBuilder builder )
        {
            javax.swing.JLabel label = builder.append( OptionPanel.getText( getLabel() ), this );
            label.setToolTipText( OptionPanel.getText( getDescription() ) );
        }

    }

    private java.util.Vector getControls()
    {
        java.util.Vector controls = new java.util.Vector();
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "Environment" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "language" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "language.tooltip", FreeMind.RESOURCE_LANGUAGE, new java.lang.String[]{ "automatic", "cs", "de", "dk", "en", "es", "fr", "hu", "it", "ja", "kr", "lt", "nl", "no", "pl", "pt_BR", "pt_PT", "ru", "sl", "zh", "zh_CN" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "files" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "last_opened_list_length" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "experimental_file_locking_on.tooltip", "experimental_file_locking_on" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "userproperties" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "patternsfile" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "docmapurl_since_version_0_7_0" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "browsemode_initial_map.tooltip", "browsemode_initial_map" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "automatic_save" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "time_for_automatic_save.tooltip", "time_for_automatic_save" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "delete_automatic_saves_at_exit.tooltip", "delete_automatic_saves_at_exit" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "number_of_different_files_for_automatic_save.tooltip", "number_of_different_files_for_automatic_save" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "path_to_automatic_saves.tooltip", "path_to_automatic_saves" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "Defaults" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "default_styles" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "standardnodestyle.tooltip", FreeMind.RESOURCES_NODE_STYLE, new java.lang.String[]{ MindMapNode.STYLE_FORK, MindMapNode.STYLE_BUBBLE, MindMapNode.STYLE_AS_PARENT, MindMapNode.STYLE_COMBINED } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "standardrootnodestyle.tooltip", FreeMind.RESOURCES_ROOT_NODE_STYLE, new java.lang.String[]{ MindMapNode.STYLE_FORK, MindMapNode.STYLE_BUBBLE, MindMapNode.STYLE_COMBINED } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "default_colors" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardnodecolor.tooltip", FreeMind.RESOURCES_NODE_COLOR, "#000000" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardselectednodecolor.tooltip", FreeMind.RESOURCES_SELECTED_NODE_COLOR, "#D2D2D2" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardedgecolor.tooltip", FreeMind.RESOURCES_EDGE_COLOR, "#808080" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardlinkcolor.tooltip", FreeMind.RESOURCES_LINK_COLOR, "#b0b0b0" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardbackgroundcolor.tooltip", FreeMind.RESOURCES_BACKGROUND_COLOR, "#ffffff" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ColorProperty( "standardcloudcolor.tooltip", FreeMind.RESOURCES_CLOUD_COLOR, "#f0f0f0" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "default_fonts" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "defaultfont.tooltip", "defaultfont" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "defaultfontstyle" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "defaultfontsize" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "max_node_width.tooltip", "max_node_width" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "other_defaults" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "standardedgestyle.tooltip", FreeMind.RESOURCES_EDGE_STYLE, new java.lang.String[]{ "bezier", "linear" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "Appearance" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "look_and_feel" ) );
        javax.swing.UIManager.LookAndFeelInfo[] lafInfo = UIManager.getInstalledLookAndFeels();
        java.lang.String[] lafNames = new java.lang.String[lafInfo.length + 5];
        java.util.Vector translatedLafNames = new java.util.Vector();
        lafNames[0] = "default";
        translatedLafNames.add( getText( "default" ) );
        lafNames[1] = "metal";
        translatedLafNames.add( getText( "metal" ) );
        lafNames[2] = "windows";
        translatedLafNames.add( getText( "windows" ) );
        lafNames[3] = "motif";
        translatedLafNames.add( getText( "motif" ) );
        lafNames[4] = "gtk";
        translatedLafNames.add( getText( "gtk" ) );
        lafNames[5] = "nothing";
        translatedLafNames.add( getText( "nothing" ) );
        for (int i = 0; i < lafInfo.length; i++) {
            javax.swing.UIManager.LookAndFeelInfo info = lafInfo[i];
            java.lang.String className = info.getClassName();
            lafNames[i + 5] = className;
            translatedLafNames.add( info.getName() );
        }
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "lookandfeel.tooltip", FreeMind.RESOURCE_LOOKANDFEEL, lafNames, translatedLafNames ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "anti_alias" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "antialias.tooltip", FreeMind.RESOURCE_ANTIALIAS, new java.lang.String[]{ "antialias_edges", "antialias_all", "antialias_none" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "initial_map_size" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "mapxsize.tooltip", "mapxsize" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "mapysize" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "hyperlink_types" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "links.tooltip", "links", new java.lang.String[]{ "relative", "absolute" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "edit_long_node_window" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "el__buttons_position.tooltip", "el__buttons_position" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( null, "el__position_window_below_node" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "el__min_default_window_height" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "el__max_default_window_height" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "el__min_default_window_width" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( null, "el__max_default_window_width" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( null, "el__enter_confirms_by_default" ) );
        java.lang.String form = "right:max(40dlu;p), 4dlu, 80dlu, 7dlu";
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "Keystrokes", form + "," + form ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "commands_for_the_program" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_newMap" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_open" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_save" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_saveAs" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_print" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_close" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_quit" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_option_dialog" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_export_to_html" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_export_branch_to_html" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_open_first_in_history" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_previousMap" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_nextMap" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_mode_MindMap" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_mode_Browse" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_mode_File" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_toggle_italic" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_toggle_boldface" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_toggle_underlined" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_toggle_cloud" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_undo" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_redo" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_delete_child" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_select_all" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_select_branch" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_zoom_out" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_zoom_in" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "node_editing_commands" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_cut" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_copy" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_copy_single" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_paste" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_remove" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add_arrow_link_action" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add_local_link_action" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "node_navigation_commands" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_moveToRoot" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_move_up" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_move_down" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_move_left" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_move_right" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_follow_link" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "new_node_commands" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add_child" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add_child_mac" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_add_sibling_before" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "node_editing_commands" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_edit" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_edit_long_node" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_join_nodes" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_toggle_folded" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_toggle_children_folded" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_set_link_by_filechooser" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_set_link_by_textfield" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_set_image_by_filechooser" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_up" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_down" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_increase_font_size" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_decrease_font_size" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_export_branch" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_color" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_node_color_blend" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_edge_color" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_find" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_find_next" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "patterns" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_1" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_2" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_3" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_4" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_5" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_6" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_7" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_8" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_9" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_10" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_11" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_12" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_13" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_14" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_15" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_16" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_17" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.KeyProperty( frame, null, "keystroke_apply_pattern_18" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "Behaviour" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "behaviour" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "placenewbranches.tooltip", "placenewbranches", new java.lang.String[]{ "first", "last" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "draganddrop.tooltip", "draganddrop" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "disable_cursor_move_paper.tooltip", "disable_cursor_move_paper" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "enable_leaves_folding.tooltip", "enable_leaves_folding" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "foldingsymbolwidth.tooltip", "foldingsymbolwidth" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "key_typing" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "disable_key_type.tooltip", "disable_key_type" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "key_type_adds_new.tooltip", "key_type_adds_new" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( FreeMind.RESOURCES_SELECTION_METHOD ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( "selection_method.tooltip", FreeMind.RESOURCES_SELECTION_METHOD, new java.lang.String[]{ "selection_method_direct", "selection_method_delayed", "selection_method_by_click" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "time_for_delayed_selection.tooltip", "time_for_delayed_selection" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "undo" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NumberProperty( "undo_levels.tooltip", "undo_levels", 2, 1000, 1 ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NewTabProperty( "HTML" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "browser" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "default_browser_command_windows_nt.tooltip", "default_browser_command_windows_nt" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "default_browser_command_windows_9x.tooltip", "default_browser_command_windows_9x" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "default_browser_command_other_os.tooltip", "default_browser_command_other_os" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.StringProperty( "default_browser_command_mac.tooltip", "default_browser_command_mac" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.ComboProperty( null, "html_export_folding", new java.lang.String[]{ "html_export_no_folding", "html_export_fold_currently_folded", "html_export_fold_all", "html_export_based_on_headings" } ) );
        controls.add( new freemind.preferences.layout.OptionPanel.NextLineProperty() );
        controls.add( new freemind.preferences.layout.OptionPanel.SeparatorProperty( "html_export" ) );
        controls.add( new freemind.preferences.layout.OptionPanel.BooleanProperty( "export_icons_in_html.tooltip", "export_icons_in_html" ) );
        return controls;
    }

    public void closeWindow()
    {
        try {
            freemind.controller.actions.generated.instance.OptionPanelWindowConfigurationStorage storage = fmMain.getController().getActionXmlFactory().createOptionPanelWindowConfigurationStorage();
            storage.setPanel( selectedPanel );
            fmMain.getController().storeDialogPositions( frame, storage, PREFERENCE_STORAGE_PROPERTY );
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        frame.dispose();
    }

}
