// This is mutant program.
// Author : ysma

package freemind.controller;


import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.InputEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Point2D;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.SwingUtilities;
import freemind.main.Tools;
import freemind.modes.MindMapNode;
import freemind.view.mindmapview.NodeMotionListenerView;
import freemind.view.mindmapview.NodeView;
import freemind.view.mindmapview.RootNodeView;


public class NodeMotionListener extends MouseAdapter implements java.awt.event.MouseMotionListener, java.awt.event.MouseListener
{

    private final freemind.controller.Controller c;

    private java.awt.Point originalStartingPoint;

    private static java.util.logging.Logger logger;

    public NodeMotionListener( freemind.controller.Controller controller )
    {
        c = controller;
        if (logger == null) {
            logger = c.getFrame().getLogger( this.getClass().getName() );
        }
    }

    public void mouseMoved( java.awt.event.MouseEvent e )
    {
    }

    private java.awt.Point dragStartingPoint = null;

    private int originalHGap;

    private int originalVGap;

    private int originalShiftY;

    private int originalParentHGap;

    private int originalParentVGap;

    private int originalParentShiftY;

    public void mouseDragged( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseDragged" );
        if ((e.getModifiersEx() & InputEvent.BUTTON1_DOWN_MASK) == InputEvent.BUTTON1_DOWN_MASK) {
            freemind.view.mindmapview.NodeView nodeV = getNodeView( e );
            java.awt.Point point = e.getPoint();
            SwingUtilities.convertPointToScreen( point, nodeV );
            if (!isActive()) {
                setDragStartingPoint( point, nodeV.getModel() );
            } else {
                java.awt.Point dragNextPoint = point;
                if ((e.getModifiersEx() & InputEvent.CTRL_DOWN_MASK) == 0) {
                    freemind.modes.MindMapNode node = nodeV.getModel();
                    node.setShiftY( getNodeShiftY( dragNextPoint, node, originalStartingPoint ) );
                    node.setHGap( getHGap( dragNextPoint, node, originalStartingPoint ) );
                    nodeV.setLocation( 0, 0 );
                    c.getModeController().nodeChanged( node );
                } else {
                    freemind.modes.MindMapNode parentNode = nodeV.getModel().getParentNode();
                    parentNode.setVGap( getVGap( dragNextPoint, parentNode, originalStartingPoint ) );
                    c.getModel().nodeChanged( parentNode );
                }
            }
        }
    }

    private int getVGap( java.awt.Point dragNextPoint, freemind.modes.MindMapNode node, java.awt.Point dragStartingPoint )
    {
        int oldVGap = originalParentVGap;
        int vGapChange = (int) ((dragNextPoint.y - dragStartingPoint.y) / c.getView().getZoom());
        oldVGap = Math.max( 0, oldVGap - vGapChange );
        return oldVGap;
    }

    private int getHGap( java.awt.Point dragNextPoint, freemind.modes.MindMapNode node, java.awt.Point dragStartingPoint )
    {
        int oldHGap = originalHGap;
        int hGapChange = (int) ((dragNextPoint.x - dragStartingPoint.x) / c.getView().getZoom());
        if (node.isLeft() != null && node.isLeft().getValue() == true) {
            hGapChange = -hGapChange;
        }
        oldHGap += +hGapChange;
        return oldHGap;
    }

    private int getNodeShiftY( java.awt.Point dragNextPoint, freemind.modes.MindMapNode node, java.awt.Point dragStartingPoint )
    {
        int shiftY = originalShiftY;
        int shiftYChange = (int) ((dragNextPoint.y - dragStartingPoint.y) / c.getView().getZoom());
        shiftY += shiftYChange;
        return shiftY;
    }

    public void mouseClicked( java.awt.event.MouseEvent e )
    {
        if (e.getButton() == 1 && e.getClickCount() == 2) {
            if (e.getY() == 0) {
                freemind.view.mindmapview.NodeView nodeV = getNodeView( e );
                freemind.modes.MindMapNode node = nodeV.getModel();
                nodeV.setLocation( 0, 0 );
                c.getModeController().moveNodePosition( node, node.getVGap(), 0, 0 );
                return;
            }
            if (e.getModifiersEx() == InputEvent.CTRL_DOWN_MASK) {
                freemind.view.mindmapview.NodeView nodeV = getNodeView( e );
                freemind.modes.MindMapNode node = nodeV.getModel().getParentNode();
                c.getModeController().moveNodePosition( node, MindMapNode.AUTO, node.getHGap(), node.getShiftY() );
                return;
            }
        }
    }

    private freemind.view.mindmapview.NodeView getNodeView( java.awt.event.MouseEvent e )
    {
        return ((freemind.view.mindmapview.NodeMotionListenerView) e.getSource()).getMovedView();
    }

    public void mouseEntered( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseEntered" );
        if (!isActive()) {
            freemind.view.mindmapview.NodeMotionListenerView v = (freemind.view.mindmapview.NodeMotionListenerView) e.getSource();
            v.setMouseEntered();
        }
    }

    public void mouseExited( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseExited" );
        if (!isActive()) {
            freemind.view.mindmapview.NodeMotionListenerView v = (freemind.view.mindmapview.NodeMotionListenerView) e.getSource();
            v.setMouseExited();
        }
    }

    private void stopDrag()
    {
        setDragStartingPoint( null, null );
    }

    public void mouseReleased( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseReleased" );
        freemind.view.mindmapview.NodeMotionListenerView v = (freemind.view.mindmapview.NodeMotionListenerView) e.getSource();
        if (!v.contains( e.getX(), e.getY() )) {
            v.setMouseExited();
        }
        if (!isActive()) {
            return;
        }
        freemind.view.mindmapview.NodeView nodeV = getNodeView( e );
        java.awt.Point point = e.getPoint();
        SwingUtilities.convertPointToScreen( point, nodeV );
        if ((e.getModifiersEx() & InputEvent.CTRL_DOWN_MASK) == 0) {
            freemind.modes.MindMapNode node = nodeV.getModel();
            freemind.modes.MindMapNode parentNode = nodeV.getModel().getParentNode();
            resetPositions( node, parentNode );
            c.getModeController().moveNodePosition( node, node.getVGap(), getHGap( point, node, originalStartingPoint ), getNodeShiftY( point, node, originalStartingPoint ) );
            c.getModeController().moveNodePosition( parentNode, parentNode.getVGap(), parentNode.getHGap(), parentNode.getShiftY() );
        } else {
            freemind.modes.MindMapNode node = nodeV.getModel();
            freemind.modes.MindMapNode parentNode = nodeV.getModel().getParentNode();
            resetPositions( node, parentNode );
            c.getModeController().moveNodePosition( node, node.getVGap(), node.getHGap(), node.getShiftY() );
            c.getModeController().moveNodePosition( parentNode, getVGap( point, parentNode, originalStartingPoint ), parentNode.getHGap(), parentNode.getShiftY() );
        }
        stopDrag();
    }

    private void resetPositions( freemind.modes.MindMapNode node, freemind.modes.MindMapNode parentNode )
    {
        node.setVGap( originalVGap );
        node.setHGap( originalHGap );
        node.setShiftY( originalShiftY );
        parentNode.setVGap( originalParentVGap );
        parentNode.setHGap( originalParentHGap );
        parentNode.setShiftY( originalParentShiftY );
    }

    public boolean isActive()
    {
        return getDragStartingPoint() != null;
    }

    void setDragStartingPoint( java.awt.Point point, freemind.modes.MindMapNode node )
    {
        if (this.dragStartingPoint == null) {
            originalStartingPoint = new java.awt.Point( point );
            originalHGap = node.getHGap();
            originalVGap = node.getVGap();
            originalShiftY = node.getShiftY();
            if (!node.isRoot()) {
                originalParentHGap = node.getParentNode().getHGap();
                originalParentVGap = node.getParentNode().getVGap();
                originalParentShiftY = node.getParentNode().getShiftY();
            }
        } else {
            if (point == null) {
                originalStartingPoint = null;
                originalHGap = 0;
                originalVGap = 0;
                originalShiftY = 0;
                originalParentHGap = 0;
                originalParentVGap = 0;
                originalParentShiftY = 0;
            }
        }
        this.dragStartingPoint = point;
    }

    java.awt.Point getDragStartingPoint()
    {
        return dragStartingPoint;
    }

}
