// This is mutant program.
// Author : ysma

package freemind.main;


import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import freemind.controller.Controller;
import freemind.controller.MenuBar;
import freemind.extensions.HookFactory;
import freemind.modes.ModeController;
import freemind.preferences.FreemindPropertyListener;
import freemind.view.mindmapview.MapView;


public class FreeMind extends javax.swing.JFrame implements freemind.main.FreeMindMain
{

    public static final java.lang.String RESOURCE_LOOKANDFEEL = "lookandfeel";

    public static final java.lang.String RESOURCE_ANTIALIAS = "antialias";

    public static final java.lang.String RESOURCE_LANGUAGE = "language";

    public static final java.lang.String RESOURCES_SELECTION_METHOD = "selection_method";

    public static final java.lang.String RESOURCES_NODE_STYLE = "standardnodestyle";

    public static final java.lang.String RESOURCES_ROOT_NODE_STYLE = "standardrootnodestyle";

    public static final java.lang.String RESOURCES_NODE_COLOR = "standardnodecolor";

    public static final java.lang.String RESOURCES_SELECTED_NODE_COLOR = "standardselectednodecolor";

    public static final java.lang.String RESOURCES_EDGE_COLOR = "standardedgecolor";

    public static final java.lang.String RESOURCES_EDGE_STYLE = "standardedgestyle";

    public static final java.lang.String RESOURCES_CLOUD_COLOR = "standardcloudcolor";

    public static final java.lang.String RESOURCES_LINK_COLOR = "standardlinkcolor";

    public static final java.lang.String RESOURCES_BACKGROUND_COLOR = "standardbackgroundcolor";

    private static java.util.logging.Logger logger = null;

    private static final java.lang.String DEFAULT_LANGUAGE = "en";

    private freemind.extensions.HookFactory nodeHookFactory;

    public static final java.lang.String version = "0.8.0";

    public java.net.URL defaultPropsURL;

    public static java.util.Properties props;

    private javax.swing.JScrollPane scrollPane = new javax.swing.JScrollPane();

    private freemind.controller.MenuBar menuBar;

    private javax.swing.JLabel status;

    private java.util.Map filetypes;

    private java.io.File autoPropertiesFile;

    private java.io.File patternsFile;

    freemind.controller.Controller c;

    private javax.swing.JPanel southPanel;

    private static java.util.PropertyResourceBundle languageResources;

    private java.util.PropertyResourceBundle defaultResources;

    public FreeMind()
    {
        super( "FreeMind" );
        if (logger == null) {
            logger = getLogger( (freemind.main.FreeMind.class).getName() );
        }
        freemind.main.FreeMindSplash splash = new freemind.main.FreeMindSplash( this );
        splash.setVisible( true );
        System.setProperty( "apple.laf.useScreenMenuBar", "true" );
        java.lang.String propsLoc = "freemind.properties";
        defaultPropsURL = ClassLoader.getSystemResource( propsLoc );
        java.util.Properties def = new java.util.Properties();
        try {
            java.io.InputStream in = defaultPropsURL.openStream();
            try {
                def.load( in );
            } catch ( java.lang.Exception ex ) {
                System.err.println( "Panic! Error while loading default properties." );
            } finally 
{
                in.close();
            }
            props = def;
            java.util.Properties user = new java.util.Properties( def );
            java.io.File userPropertiesFolder = new java.io.File( getFreemindDirectory() );
            java.io.File userProperties = new java.io.File( userPropertiesFolder, def.getProperty( "userproperties" ) );
            autoPropertiesFile = new java.io.File( userPropertiesFolder, def.getProperty( "autoproperties" ) );
            patternsFile = new java.io.File( userPropertiesFolder, def.getProperty( "patternsfile" ) );
            try {
                if (getProperty( "properties_folder" ).startsWith( "." )) {
                    java.lang.String oldFolderName = System.getProperty( "user.home" ) + System.getProperty( "file.separator" ) + getProperty( "properties_folder" ).substring( 1 );
                    java.io.File oldFolder = new java.io.File( oldFolderName );
                    if (oldFolder.exists() && !userPropertiesFolder.exists()) {
                        System.out.println( "Try to move the properties folder to .properties folder." );
                        oldFolder.renameTo( userPropertiesFolder );
                    }
                }
                if (!userPropertiesFolder.exists()) {
                    userPropertiesFolder.mkdir();
                }
                System.out.println();
                System.out.println( "Looking for user properties:" );
                System.out.println( userProperties );
                System.out.println();
                if (userProperties.exists()) {
                    in = new java.io.FileInputStream( userProperties );
                    user.load( in );
                    System.out.println( "User properties found." );
                } else {
                    java.lang.String output;
                    System.out.println( "User properties not found. It will be automatically created." );
                    output = new java.lang.String( "# automatically generated user.properties file.\n# generated by Freemind version " + version + "\n# To change an option, please remove the '#' at the front of the corresponding line and restart freemind. Otherwise, the changes are ignored.\n" );
                    java.lang.String userPropsLoc = "user.properties";
                    java.net.URL userPropsURL = ClassLoader.getSystemResource( userPropsLoc );
                    java.io.InputStream inProp = userPropsURL.openStream();
                    try {
                        java.io.BufferedReader br = new java.io.BufferedReader( new java.io.InputStreamReader( inProp ) );
                        java.lang.String line;
                        while ((line = br.readLine()) != null) {
                            output += "#" + line + "\n";
                        }
                        java.io.BufferedWriter fileout = new java.io.BufferedWriter( new java.io.OutputStreamWriter( new java.io.FileOutputStream( userProperties ) ) );
                        try {
                            fileout.write( output );
                            System.out.println( "Done." );
                        } catch ( java.lang.Exception ex ) {
                            System.err.println( ex );
                        } finally 
{
                            fileout.close();
                        }
                    } catch ( java.lang.Exception ex ) {
                        System.err.println( ex );
                    } finally 
{
                        inProp.close();
                    }
                }
            } catch ( java.lang.Exception ex ) {
                System.err.println( ex );
            } finally 
{
                in.close();
            }
            java.util.Properties auto = new java.util.Properties( user );
            try {
                in = new java.io.FileInputStream( autoPropertiesFile );
                auto.load( in );
            } catch ( java.lang.Exception ex ) {
            } finally 
{
                in.close();
            }
            props = auto;
        } catch ( java.lang.Exception ex ) {
        }
        updateLookAndFeel();
        javax.swing.ImageIcon icon = new javax.swing.ImageIcon( getResource( "images/FreeMindWindowIcon.png" ) );
        setIconImage( icon.getImage() );
        getContentPane().setLayout( new java.awt.BorderLayout() );
        c = new freemind.controller.Controller( this );
        Controller.addPropertyChangeListener( new freemind.preferences.FreemindPropertyListener(){
            public void propertyChanged( java.lang.String propertyName, java.lang.String newValue, java.lang.String oldValue )
            {
                if (propertyName.equals( RESOURCE_LANGUAGE )) {
                    languageResources = null;
                    getResources();
                }
            }
        } );
        c.optionAntialiasAction.changeAntialias( getProperty( RESOURCE_ANTIALIAS ) );
        menuBar = new freemind.controller.MenuBar( c );
        setJMenuBar( menuBar );
        int win_width = Integer.parseInt( props.getProperty( "appwindow_width", "0" ) );
        int win_height = Integer.parseInt( props.getProperty( "appwindow_height", "0" ) );
        win_width = win_width > 0 ? win_width : 640;
        win_height = win_height > 0 ? win_height : 440;
        getRootPane().setPreferredSize( new java.awt.Dimension( win_width, win_height ) );
        getContentPane().add( scrollPane, BorderLayout.CENTER );
        southPanel = new javax.swing.JPanel( new java.awt.BorderLayout() );
        status = new javax.swing.JLabel();
        southPanel.add( status, BorderLayout.SOUTH );
        getContentPane().add( southPanel, BorderLayout.SOUTH );
        setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
        addWindowListener( new java.awt.event.WindowAdapter(){
            public void windowClosing( java.awt.event.WindowEvent e )
            {
                c.quit.actionPerformed( new java.awt.event.ActionEvent( this, 0, "quit" ) );
            }

            public void windowActivated( java.awt.event.WindowEvent e )
            {
                if (getView() != null && getView().getSelected() != null) {
                    getView().getSelected().requestFocus();
                }
            }
        } );
        SwingUtilities.updateComponentTreeUI( this );
        c.changeToMode( getProperty( "initial_mode" ) );
        splash.setVisible( false );
    }

    private void updateLookAndFeel()
    {
        try {
            java.lang.String lookAndFeel = props.getProperty( RESOURCE_LOOKANDFEEL );
            if (lookAndFeel.equals( "windows" )) {
                UIManager.setLookAndFeel( "com.sun.java.swing.plaf.windows.WindowsLookAndFeel" );
            } else {
                if (lookAndFeel.equals( "motif" )) {
                    UIManager.setLookAndFeel( "com.sun.java.swing.plaf.motif.MotifLookAndFeel" );
                } else {
                    if (lookAndFeel.equals( "mac" )) {
                        UIManager.setLookAndFeel( "javax.swing.plaf.mac.MacLookAndFeel" );
                    } else {
                        if (lookAndFeel.equals( "metal" )) {
                            UIManager.setLookAndFeel( "javax.swing.plaf.metal.MetalLookAndFeel" );
                        } else {
                            if (lookAndFeel.equals( "gtk" )) {
                                UIManager.setLookAndFeel( "com.sun.java.swing.plaf.gtk.GTKLookAndFeel" );
                            } else {
                                if (lookAndFeel.equals( "nothing" )) {
                                } else {
                                    if (lookAndFeel.indexOf( '.' ) != -1) {
                                        UIManager.setLookAndFeel( lookAndFeel );
                                    } else {
                                        System.out.println( "Default (System) Look & Feel: " + UIManager.getSystemLookAndFeelClassName() );
                                        UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } catch ( java.lang.Exception ex ) {
            System.err.println( "Unable to set Look & Feel." );
        }
    }

    public boolean isApplet()
    {
        return false;
    }

    public java.io.File getPatternsFile()
    {
        return patternsFile;
    }

    public java.awt.Container getViewport()
    {
        return scrollPane.getViewport();
    }

    public java.lang.String getFreemindVersion()
    {
        return version;
    }

    public int getWinHeight()
    {
        return getRootPane().getHeight();
    }

    public int getWinWidth()
    {
        return getRootPane().getWidth();
    }

    public int getWinState()
    {
        return getExtendedState();
    }

    public java.net.URL getResource( java.lang.String name )
    {
        return ClassLoader.getSystemResource( name );
    }

    public java.lang.String getProperty( java.lang.String key )
    {
        return props.getProperty( key );
    }

    public int getIntProperty( java.lang.String key, int defaultValue )
    {
        try {
            return Integer.parseInt( getProperty( key ) );
        } catch ( java.lang.NumberFormatException nfe ) {
            return defaultValue;
        }
    }

    public java.util.Properties getProperties()
    {
        return props;
    }

    public void setProperty( java.lang.String key, java.lang.String value )
    {
        props.setProperty( key, value );
    }

    public java.lang.String getFreemindDirectory()
    {
        return System.getProperty( "user.home" ) + System.getProperty( "file.separator" ) + getProperty( "properties_folder" );
    }

    public void saveProperties()
    {
        try {
            java.io.OutputStream out = new java.io.FileOutputStream( autoPropertiesFile );
            props.store( out, null );
            out.close();
        } catch ( java.lang.Exception ex ) {
        }
    }

    public freemind.view.mindmapview.MapView getView()
    {
        return c.getView();
    }

    public freemind.controller.Controller getController()
    {
        return c;
    }

    public void setView( freemind.view.mindmapview.MapView view )
    {
        scrollPane.setViewportView( view );
        if (view != null) {
            view.setAutoscrolls( true );
        }
    }

    public freemind.controller.MenuBar getFreeMindMenuBar()
    {
        return menuBar;
    }

    public void out( java.lang.String msg )
    {
        status.setText( msg );
    }

    public void err( java.lang.String msg )
    {
        status.setText( msg );
    }

    public void openDocument( java.net.URL url )
        throws java.lang.Exception
    {
        java.lang.String correctedUrl = new java.lang.String( url.toExternalForm() );
        if (url.getProtocol().equals( "file" )) {
            correctedUrl = correctedUrl.replace( '\\', '/' ).replaceAll( " ", "%20" );
        }
        java.lang.String osName = System.getProperty( "os.name" );
        if (osName.substring( 0, 3 ).equals( "Win" )) {
            java.lang.String propertyString = new java.lang.String( "default_browser_command_windows" );
            if (osName.indexOf( "9" ) != -1 || osName.indexOf( "Me" ) != -1) {
                propertyString += "_9x";
            } else {
                propertyString += "_nt";
            }
            java.lang.String browser_command = new java.lang.String();
            java.lang.String command = new java.lang.String();
            try {
                java.lang.Object[] messageArguments = { url.toString() };
                java.text.MessageFormat formatter = new java.text.MessageFormat( getProperty( propertyString ) );
                browser_command = formatter.format( messageArguments );
                if (url.getProtocol().equals( "file" )) {
                    command = "rundll32 url.dll,FileProtocolHandler " + Tools.urlGetFile( url );
                } else {
                    if (url.toString().startsWith( "mailto:" )) {
                        command = "rundll32 url.dll,FileProtocolHandler " + url.toString();
                    } else {
                        command = browser_command;
                    }
                }
                Runtime.getRuntime().exec( command );
            } catch ( java.io.IOException x ) {
                c.errorMessage( "Could not invoke browser.\n\nFreemind excecuted the following statement on a command line:\n\"" + command + "\".\n\nYou may look at the user or default property called '" + propertyString + "'." );
                System.err.println( "Caught: " + x );
            }
        } else {
            if (osName.startsWith( "Mac OS" )) {
                java.lang.String browser_command = new java.lang.String();
                try {
                    java.lang.Object[] messageArguments = { correctedUrl, url.toString() };
                    java.text.MessageFormat formatter = new java.text.MessageFormat( getProperty( "default_browser_command_mac" ) );
                    browser_command = formatter.format( messageArguments );
                    Runtime.getRuntime().exec( browser_command );
                } catch ( java.io.IOException ex2 ) {
                    c.errorMessage( "Could not invoke browser.\n\nFreemind excecuted the following statement on a command line:\n\"" + browser_command + "\".\n\nYou may look at the user or default property called 'default_browser_command_mac'." );
                    System.err.println( "Caught: " + ex2 );
                }
            } else {
                java.lang.String browser_command = new java.lang.String();
                try {
                    java.lang.Object[] messageArguments = { correctedUrl, url.toString() };
                    java.text.MessageFormat formatter = new java.text.MessageFormat( getProperty( "default_browser_command_other_os" ) );
                    browser_command = formatter.format( messageArguments );
                    Runtime.getRuntime().exec( browser_command );
                } catch ( java.io.IOException ex2 ) {
                    c.errorMessage( "Could not invoke browser.\n\nFreemind excecuted the following statement on a command line:\n\"" + browser_command + "\".\n\nYou may look at the user or default property called 'default_browser_command_other_os'." );
                    System.err.println( "Caught: " + ex2 );
                }
            }
        }
    }

    private java.lang.String transpose( java.lang.String input, char findChar, java.lang.String replaceString )
    {
        java.lang.String res = new java.lang.String();
        for (int i = 0; i < input.length(); ++i) {
            char d = input.charAt( i-- );
            if (d == findChar) {
                res += replaceString;
            } else {
                res += d;
            }
        }
        return res;
    }

    public void setWaitingCursor( boolean waiting )
    {
        if (waiting) {
            getRootPane().getGlassPane().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
            getRootPane().getGlassPane().setVisible( true );
        } else {
            getRootPane().getGlassPane().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
            getRootPane().getGlassPane().setVisible( false );
        }
    }

    private java.lang.String getProgramForFile( java.lang.String type )
    {
        if (filetypes == null) {
            filetypes = new java.util.HashMap();
            java.lang.String raw = getProperty( "filetypes" );
            if (raw == null || raw.equals( "" )) {
                return "";
            }
            java.util.StringTokenizer tokens = new java.util.StringTokenizer( raw, "," );
            while (tokens.hasMoreTokens()) {
                java.util.StringTokenizer pair = new java.util.StringTokenizer( tokens.nextToken(), ":" );
                java.lang.String key = pair.nextToken().trim().toLowerCase();
                java.lang.String value = pair.nextToken().trim();
                filetypes.put( key, value );
            }
        }
        return (java.lang.String) filetypes.get( type.trim().toLowerCase() );
    }

    public java.util.ResourceBundle getResources()
    {
        if (languageResources == null) {
            try {
                java.lang.String lang = getProperty( RESOURCE_LANGUAGE );
                if (lang == null || lang.equals( "automatic" )) {
                    lang = Locale.getDefault().getLanguage() + "_" + Locale.getDefault().getCountry();
                    if (getLanguageResources( lang ) == null) {
                        lang = Locale.getDefault().getLanguage();
                        if (getLanguageResources( lang ) == null) {
                            lang = DEFAULT_LANGUAGE;
                        }
                    }
                }
                languageResources = getLanguageResources( lang );
                defaultResources = getLanguageResources( DEFAULT_LANGUAGE );
            } catch ( java.lang.Exception ex ) {
                ex.printStackTrace();
                System.err.println( "Error loading Resources" );
                return null;
            }
        }
        return languageResources;
    }

    public java.lang.String getResourceString( java.lang.String resource )
    {
        try {
            return getResources().getString( resource );
        } catch ( java.lang.Exception ex ) {
            System.err.println( "Warning - resource string not found:" + resource );
            try {
                return defaultResources.getString( resource ) + "[translate me]";
            } catch ( java.lang.Exception e ) {
                System.err.println( "Warning - resource string not found (even in english):" + resource );
                return resource;
            }
        }
    }

    private java.util.PropertyResourceBundle getLanguageResources( java.lang.String lang )
        throws java.io.IOException
    {
        java.net.URL systemResource = ClassLoader.getSystemResource( "Resources_" + lang + ".properties" );
        if (systemResource == null) {
            return null;
        }
        java.io.InputStream in = systemResource.openStream();
        if (in == null) {
            return null;
        }
        java.util.PropertyResourceBundle bundle = new java.util.PropertyResourceBundle( in );
        in.close();
        return bundle;
    }

    public java.util.logging.Logger getLogger( java.lang.String forClass )
    {
        return java.util.logging.Logger.getLogger( forClass );
    }

    public static void main( java.lang.String[] args )
    {
        freemind.main.FreeMind frame = new freemind.main.FreeMind();
        frame.c.checkJavaVersion();
        freemind.modes.ModeController ctrl = frame.c.getMode().getModeController();
        boolean fileLoaded = false;
        for (int i = 0; i < args.length; i++) {
            if (args[i].toLowerCase().endsWith( ".mm" )) {
                if (!Tools.isAbsolutePath( args[i] )) {
                    args[i] = System.getProperty( "user.dir" ) + System.getProperty( "file.separator" ) + args[i];
                }
                try {
                    ctrl.load( new java.io.File( args[i] ) );
                    fileLoaded = true;
                } catch ( java.lang.Exception ex ) {
                    System.err.println( "File " + args[i] + "not found error" );
                }
            }
        }
        if (!fileLoaded && frame.getProperty( "onStartIfNotSpecified" ) != null) {
            frame.c.getLastOpenedList().open( frame.getProperty( "onStartIfNotSpecified" ) );
        }
        frame.pack();
        try {
            if (frame.getView() != null) {
                if (!EventQueue.isDispatchThread()) {
                    EventQueue.invokeAndWait( new java.lang.Runnable(){
                        public void run()
                        {
                        }
                    } );
                }
                frame.getView().moveToRoot();
            }
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
        }
        if (Tools.safeEquals( frame.getProperty( "toolbarVisible" ), "false" )) {
            frame.c.setToolbarVisible( false );
        }
        if (Tools.safeEquals( frame.getProperty( "leftToolbarVisible" ), "false" )) {
            frame.c.setLeftToolbarVisible( false );
        }
        frame.setVisible( true );
        int win_state = Integer.parseInt( FreeMind.props.getProperty( "appwindow_state", "0" ) );
        win_state = (win_state & ICONIFIED) != 0 ? NORMAL : win_state;
        frame.setExtendedState( win_state );
    }

    public freemind.extensions.HookFactory getHookFactory()
    {
        if (nodeHookFactory == null) {
            nodeHookFactory = new freemind.extensions.HookFactory( this );
        }
        return nodeHookFactory;
    }

    public javax.swing.JPanel getSouthPanel()
    {
        return southPanel;
    }

    public javax.swing.JFrame getJFrame()
    {
        return this;
    }

}
