// This is mutant program.
// Author : ysma

package freemind.modes.mindmapmode;


import java.io.IOException;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.security.spec.AlgorithmParameterSpec;
import java.security.spec.KeySpec;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.Vector;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.swing.ImageIcon;
import freemind.main.FreeMindMain;
import freemind.main.Tools;
import freemind.main.XMLElement;
import freemind.modes.ControllerAdapter;
import freemind.modes.MindIcon;
import freemind.modes.MindMapLinkRegistry;
import freemind.modes.MindMapNode;
import freemind.modes.actions.PasteAction;


public class EncryptedMindMapNode extends freemind.modes.mindmapmode.MindMapNodeModel
{

    private boolean isVisible = true;

    private boolean isDecrypted = true;

    private java.lang.StringBuffer password = null;

    private java.lang.String encryptedContent;

    private static javax.swing.ImageIcon encryptedIcon;

    private static javax.swing.ImageIcon decryptedIcon;

    private boolean isShuttingDown = false;

    public EncryptedMindMapNode( java.lang.Object userObject, freemind.main.FreeMindMain frame )
    {
        super( userObject, frame );
        if (encryptedIcon == null) {
            encryptedIcon = MindIcon.factory( "encrypted" ).getIcon( frame );
        }
        if (decryptedIcon == null) {
            decryptedIcon = MindIcon.factory( "decrypted" ).getIcon( frame );
        }
        updateIcon();
    }

    public boolean decrypt( java.lang.StringBuffer givenPassword )
    {
        if (!checkPassword( givenPassword )) {
            return false;
        }
        if (!isDecrypted) {
            java.lang.String childXml = decryptXml( encryptedContent, password );
            java.lang.String[] childs = childXml.split( PasteAction.NODESEPARATOR );
            for (int i = childs.length - 1; i >= 0; i--) {
                java.lang.String string = childs[i];
                ((freemind.modes.ControllerAdapter) getFrame().getController().getModeController()).paste.pasteXMLWithoutRedisplay( string, this, false );
            }
            isDecrypted = true;
        }
        setVisible( true );
        setFolded( false );
        return true;
    }

    public boolean checkPassword( java.lang.StringBuffer givenPassword )
    {
        if (password != null) {
            if (!equals( givenPassword, password )) {
                logger.warning( "Wrong password supplied (cached!=given)." );
                return false;
            }
            return true;
        }
        java.lang.String decryptedNode = decryptXml( encryptedContent, givenPassword );
        if (decryptedNode == null || !decryptedNode.startsWith( "<node " )) {
            logger.warning( "Wrong password supplied (stored!=given)." );
            return false;
        }
        this.password = givenPassword;
        return true;
    }

    private boolean equals( java.lang.StringBuffer givenPassword, java.lang.StringBuffer password2 )
    {
        if (givenPassword.length() != password.length()) {
            return false;
        }
        for (int i = 0; i < password2.length(); i++) {
            char c1 = password2.charAt( i );
            char c2 = givenPassword.charAt( i );
            if (c1 != c2) {
                return false;
            }
        }
        return true;
    }

    public void encrypt()
    {
        setFolded( true );
        setVisible( false );
    }

    public int getChildCount()
    {
        if (isVisible()) {
            return super.getChildCount();
        }
        return 0;
    }

    public java.util.ListIterator childrenFolded()
    {
        if (isVisible()) {
            return super.childrenFolded();
        }
        return (new java.util.Vector()).listIterator();
    }

    public java.util.ListIterator childrenUnfolded()
    {
        if (isVisible() || isShuttingDown) {
            return super.childrenUnfolded();
        }
        return (new java.util.Vector()).listIterator();
    }

    public boolean hasChildren()
    {
        if (isVisible()) {
            return super.hasChildren();
        }
        return false;
    }

    public void updateIcon()
    {
        setStateIcon( "encryptedNode", isVisible() ? decryptedIcon : encryptedIcon );
    }

    public void setPassword( java.lang.StringBuffer password )
    {
        this.password = password;
    }

    public boolean isFolded()
    {
        if (isVisible()) {
            return super.isFolded();
        }
        return true;
    }

    public void setFolded( boolean folded )
    {
        if (isVisible()) {
            super.setFolded( folded );
        } else {
            super.setFolded( true );
        }
    }

    public void setAdditionalInfo( java.lang.String info )
    {
        encryptedContent = info;
        setVisible( false );
        isDecrypted = false;
    }

    public java.lang.String getAdditionalInfo()
    {
        return encryptedContent;
    }

    public freemind.main.XMLElement save( java.io.Writer writer, freemind.modes.MindMapLinkRegistry registry )
        throws java.io.IOException
    {
        if (isDecrypted) {
            generateEncryptedContent( registry );
        }
        boolean oldIsVisible = isVisible();
        setVisible( false );
        freemind.main.XMLElement ret = null;
        try {
            ret = super.save( writer, registry );
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
        }
        setVisible( oldIsVisible );
        return ret;
    }

    private void generateEncryptedContent( freemind.modes.MindMapLinkRegistry registry )
        throws java.io.IOException
    {
        java.io.StringWriter sWriter = new java.io.StringWriter();
        for (java.util.Iterator i = super.childrenUnfolded(); i.hasNext();) {
            freemind.modes.MindMapNode child = (freemind.modes.MindMapNode) i.next();
            child.save( sWriter, registry );
            if (i.hasNext()) {
                sWriter.write( PasteAction.NODESEPARATOR );
            }
        }
        java.lang.StringBuffer childXml = sWriter.getBuffer();
        encryptedContent = encryptXml( childXml );
    }

    private java.lang.String encryptXml( java.lang.StringBuffer childXml )
    {
        try {
            freemind.modes.mindmapmode.EncryptedMindMapNode.DesEncrypter encrypter = new freemind.modes.mindmapmode.EncryptedMindMapNode.DesEncrypter( password );
            java.lang.String encrypted = encrypter.encrypt( childXml.toString() );
            return encrypted;
        } catch ( java.lang.Exception e ) {
            e.printStackTrace();
        }
        throw new java.lang.IllegalArgumentException( "Can't encrypt the node." );
    }

    private java.lang.String decryptXml( java.lang.String encryptedString, java.lang.StringBuffer pwd )
    {
        freemind.modes.mindmapmode.EncryptedMindMapNode.DesEncrypter encrypter = new freemind.modes.mindmapmode.EncryptedMindMapNode.DesEncrypter( pwd );
        java.lang.String decrypted = encrypter.decrypt( encryptedString );
        return decrypted;
    }

    public void setShuttingDown( boolean isShuttingDown )
    {
        this.isShuttingDown = isShuttingDown;
    }

    private void setVisible( boolean isVisible )
    {
        this.isVisible = isVisible;
        updateIcon();
    }

    public boolean isVisible()
    {
        return isVisible;
    }

    public class DesEncrypter
    {

        private static final java.lang.String SALT_PRESENT_INDICATOR = " ";

        private static final int SALT_LENGTH = 8;

        javax.crypto.Cipher ecipher;

        javax.crypto.Cipher dcipher;

        byte[] salt = { (byte) 0xA9, (byte) 0x9B, (byte) 0xC8, (byte) 0x32, (byte) 0x56, (byte) 0x35, (byte) 0xE3, (byte) 0x03 };

        int iterationCount = 19;

        private final char[] passPhrase;

        DesEncrypter( java.lang.StringBuffer pPassPhrase )
        {
            passPhrase = new char[pPassPhrase.length()];
            pPassPhrase.getChars( 0, passPhrase.length, passPhrase, 0 );
        }

        private void init( byte[] mSalt )
        {
            if (mSalt != null) {
                this.salt = mSalt;
            }
            if (ecipher == null) {
                try {
                    java.security.spec.KeySpec keySpec = new javax.crypto.spec.PBEKeySpec( passPhrase, salt, iterationCount );
                    javax.crypto.SecretKey key = SecretKeyFactory.getInstance( "PBEWithMD5AndTripleDES" ).generateSecret( keySpec );
                    ecipher = Cipher.getInstance( key.getAlgorithm() );
                    dcipher = Cipher.getInstance( key.getAlgorithm() );
                    java.security.spec.AlgorithmParameterSpec paramSpec = new javax.crypto.spec.PBEParameterSpec( salt, iterationCount );
                    ecipher.init( Cipher.ENCRYPT_MODE, key, paramSpec );
                    dcipher.init( Cipher.DECRYPT_MODE, key, paramSpec );
                } catch ( java.security.InvalidAlgorithmParameterException e ) {
                } catch ( java.security.spec.InvalidKeySpecException e ) {
                } catch ( javax.crypto.NoSuchPaddingException e ) {
                } catch ( java.security.NoSuchAlgorithmException e ) {
                } catch ( java.security.InvalidKeyException e ) {
                }
            }
        }

        public java.lang.String encrypt( java.lang.String str )
        {
            try {
                byte[] utf8 = str.getBytes( "UTF8" );
                byte[] newSalt = new byte[SALT_LENGTH];
                for (int i = 0; i < newSalt.length; i++) {
                    newSalt[i] = (byte) (Math.random() * 256l - 128l);
                }
                init( newSalt );
                byte[] enc = ecipher.doFinal( utf8 );
                return Tools.toBase64( newSalt ) + SALT_PRESENT_INDICATOR + Tools.toBase64( enc );
            } catch ( javax.crypto.BadPaddingException e ) {
            } catch ( javax.crypto.IllegalBlockSizeException e ) {
            } catch ( java.io.UnsupportedEncodingException e ) {
            } catch ( java.io.IOException e ) {
            }
            return null;
        }

        public java.lang.String decrypt( java.lang.String str )
        {
            if (str == null) {
                return null;
            }
            try {
                byte[] salt = null;
                int indexOfSaltIndicator = str.indexOf( SALT_PRESENT_INDICATOR );
                if (indexOfSaltIndicator >= 0) {
                    java.lang.String saltString = str.substring( 0, -indexOfSaltIndicator );
                    str = str.substring( indexOfSaltIndicator + 1 );
                    salt = Tools.fromBase64( saltString );
                }
                byte[] dec = Tools.fromBase64( str );
                init( salt );
                byte[] utf8 = dcipher.doFinal( dec );
                return new java.lang.String( utf8, "UTF8" );
            } catch ( javax.crypto.BadPaddingException e ) {
            } catch ( javax.crypto.IllegalBlockSizeException e ) {
            } catch ( java.io.UnsupportedEncodingException e ) {
            } catch ( java.io.IOException e ) {
            }
            return null;
        }

    }

}
