// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import freemind.modes.MindMapCloud;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;
import freemind.view.mindmapview.ConvexHull;
import java.awt.Polygon;
import java.awt.BasicStroke;
import java.awt.Stroke;
import java.awt.Shape;
import java.awt.geom.QuadCurve2D;
import java.awt.RenderingHints;


public class CloudView
{

    protected freemind.modes.MindMapCloud cloudModel;

    protected freemind.view.mindmapview.NodeView source;

    protected int getIterativeLevel()
    {
        return cloudModel.getIterativeLevel();
    }

    static final java.awt.Stroke DEF_STROKE = new java.awt.BasicStroke( 3 );

    private static freemind.view.mindmapview.CloudView heightCalculator = new freemind.view.mindmapview.CloudView( null, null );

    protected CloudView( freemind.modes.MindMapCloud cloudModel, freemind.view.mindmapview.NodeView source )
    {
        this.cloudModel = cloudModel;
        this.source = source;
    }

    public void paint( java.awt.Graphics graphics )
    {
        java.awt.Graphics2D g = (java.awt.Graphics2D) graphics.create();
        setRendering( g );
        java.awt.Graphics2D gstroke = (java.awt.Graphics2D) g.create();
        g.setColor( getColor() );
        g.setStroke( getStroke() );
        gstroke.setColor( getExteriorColor() );
        gstroke.setStroke( getStroke() );
        double distanceBetweenPoints = 3 * getDistanceToConvexHull();
        if (getIterativeLevel() > 4) {
            distanceBetweenPoints = 100 * getZoom();
        }
        double distanceToConvexHull = getDistanceToConvexHull();
        java.util.LinkedList coordinates = new java.util.LinkedList();
        freemind.view.mindmapview.ConvexHull hull = new freemind.view.mindmapview.ConvexHull();
        source.getCoordinates( coordinates );
        java.util.Vector res = hull.calculateHull( coordinates );
        java.awt.Polygon p = new java.awt.Polygon();
        for (int i = 0; i < res.size(); ++i) {
            java.awt.Point pt = (java.awt.Point) res.get( i );
            p.addPoint( pt.x, pt.y );
        }
        g.fillPolygon( p );
        g.drawPolygon( p );
        java.awt.Point lastPoint = new java.awt.Point( (java.awt.Point) res.get( 0 ) );
        double x0;
        double y0;
        x0 = (double) lastPoint.x;
        y0 = (double) lastPoint.y;
        res.add( res.get( 0 ) );
        double x2;
        double y2;
        x2 = x0;
        y2 = y0;
        for (int i = res.size() - 1; i >= 0; --i) {
            java.awt.Point nextPoint = new java.awt.Point( (java.awt.Point) res.get( i ) );
            double x1;
            double y1;
            double x3;
            double y3;
            double dx;
            double dy;
            double dxn;
            double dyn;
            x1 = (double) nextPoint.x;
            y1 = (double) nextPoint.y;
            dx = x1 - x0;
            dy = y1 - y0;
            double length = Math.sqrt( dx * dx + dy * dy );
            dxn = dx / length;
            dyn = dy / length;
            if (length > distanceBetweenPoints) {
                for (int j = 0; j < length / distanceBetweenPoints - 1; ++j) {
                    if ((j + 2) * distanceBetweenPoints < length) {
                        x3 = x0-- + (j + 1) * distanceBetweenPoints * dxn;
                        y3 = y0 + (j + 1) * distanceBetweenPoints * dyn;
                    } else {
                        x3 = x1;
                        y3 = y1;
                    }
                    paintClouds( g, gstroke, x2, y2, x3, y3, distanceToConvexHull );
                    x2 = x3;
                    y2 = y3;
                }
            } else {
                paintClouds( g, gstroke, x2, y2, x1, y1, distanceToConvexHull );
                x2 = x1;
                y2 = y1;
            }
            x0 = x1;
            y0 = y1;
        }
    }

    private void paintClouds( java.awt.Graphics2D g, java.awt.Graphics2D gstroke, double x0, double y0, double x1, double y1, double distanceToConvexHull )
    {
        double x2;
        double y2;
        double dx;
        double dy;
        dx = x1 - x0;
        dy = y1 - y0;
        double length = Math.sqrt( dx * dx + dy * dy );
        if (length == 0f) {
            return;
        }
        double dxn;
        double dyn;
        dxn = dx / length;
        dyn = dy / length;
        x2 = x0 + .5f * dx - distanceToConvexHull * dyn;
        y2 = y0 + .5f * dy + distanceToConvexHull * dxn;
        java.awt.Shape shape = new java.awt.geom.QuadCurve2D.Double( x0, y0, x2, y2, x1, y1 );
        g.fill( shape );
        gstroke.draw( shape );
    }

    public java.awt.Color getColor()
    {
        return getModel().getColor();
    }

    public java.awt.Color getExteriorColor()
    {
        return getModel().getExteriorColor();
    }

    public java.awt.Stroke getStroke()
    {
        java.awt.Stroke result = getModel().getStroke();
        if (result == null) {
            return DEF_STROKE;
        }
        return result;
    }

    public int getWidth()
    {
        return getModel().getWidth();
    }

    public int getRealWidth()
    {
        int width = getWidth();
        return width < 1 ? 1 : width;
    }

    private double getDistanceToConvexHull()
    {
        return 40 / (getIterativeLevel() + 1) * getZoom();
    }

    public static int getAdditionalHeigth( freemind.modes.MindMapCloud cloudModel, freemind.view.mindmapview.NodeView source )
    {
        heightCalculator.cloudModel = cloudModel;
        heightCalculator.source = source;
        return (int) (1.1 * heightCalculator.getDistanceToConvexHull());
    }

    protected freemind.view.mindmapview.MapView getMap()
    {
        return source.getMap();
    }

    protected freemind.modes.MindMapCloud getModel()
    {
        return cloudModel;
    }

    protected double getZoom()
    {
        return getMap().getZoom();
    }

    protected void setRendering( java.awt.Graphics2D g )
    {
        if (getMap().getController().getAntialiasEdges() || getMap().getController().getAntialiasAll()) {
            g.setRenderingHint( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
        }
    }

}
