// This is mutant program.
// Author : ysma

package freemind.controller;


import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Point2D;
import java.util.Timer;
import java.util.TimerTask;
import freemind.main.Tools;
import freemind.view.mindmapview.NodeView;


public class NodeMouseMotionListener implements java.awt.event.MouseMotionListener, java.awt.event.MouseListener
{

    private final freemind.controller.Controller c;

    private static java.util.logging.Logger logger;

    private static freemind.main.Tools.IntHolder timeForDelayedSelection;

    private static freemind.main.Tools.BooleanHolder delayedSelectionEnabled;

    public static void updateSelectionMethod( freemind.controller.Controller c )
    {
        if (timeForDelayedSelection == null) {
            timeForDelayedSelection = new freemind.main.Tools.IntHolder();
        }
        delayedSelectionEnabled = new freemind.main.Tools.BooleanHolder();
        delayedSelectionEnabled.setValue( c.getFrame().getProperty( "selection_method" ).equals( "selection_method_direct" ) ? false : true );
        if (c.getFrame().getProperty( "selection_method" ).equals( "selection_method_by_click" )) {
            timeForDelayedSelection.setValue( Integer.MAX_VALUE );
        } else {
            timeForDelayedSelection.setValue( Integer.parseInt( c.getFrame().getProperty( "time_for_delayed_selection" ) ) );
        }
    }

    private java.util.Timer timerForDelayedSelection;

    private java.awt.Rectangle controlRegionForDelayedSelection;

    public NodeMouseMotionListener( freemind.controller.Controller controller )
    {
        c = controller;
        if (logger == null) {
            logger = c.getFrame().getLogger( this.getClass().getName() );
        }
        if (delayedSelectionEnabled == null) {
            updateSelectionMethod( c );
        }
    }

    public void mouseMoved( java.awt.event.MouseEvent e )
    {
        logger.finest( "Event: mouseMoved" );
        freemind.view.mindmapview.NodeView node = (freemind.view.mindmapview.NodeView) e.getComponent();
        boolean isLink = node.updateCursor( e.getX() );
        if (isLink) {
            c.getFrame().out( c.getModeController().getLinkShortText( node.getModel() ) );
        }
        if (controlRegionForDelayedSelection != null && delayedSelectionEnabled.getValue()) {
            if (!controlRegionForDelayedSelection.contains( e.getPoint() )) {
                createTimer( e );
            }
        }
    }

    public void mouseDragged( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseDragged" );
        stopTimerForDelayedSelection();
        freemind.view.mindmapview.NodeView nodeV = (freemind.view.mindmapview.NodeView) e.getSource();
        if (!c.getView().isSelected( nodeV )) {
            c.getMode().getModeController().extendSelection( e );
        }
    }

    public void mouseClicked( java.awt.event.MouseEvent e )
    {
    }

    public void mouseEntered( java.awt.event.MouseEvent e )
    {
        logger.finest( "Event: mouseEntered" );
        createTimer( e );
    }

    public void mousePressed( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mousePressed" );
        c.getMode().getModeController().showPopupMenu( e );
    }

    public void mouseExited( java.awt.event.MouseEvent e )
    {
        logger.finest( "Event: mouseExited" );
        stopTimerForDelayedSelection();
    }

    public void mouseReleased( java.awt.event.MouseEvent e )
    {
        logger.fine( "Event: mouseReleased" );
        stopTimerForDelayedSelection();
        c.getMode().getModeController().extendSelection( e );
        c.getMode().getModeController().showPopupMenu( e );
        if (e.isConsumed()) {
            return;
        }
        if (e.getModifiers() == MouseEvent.BUTTON1_MASK) {
            if (e.getClickCount() % 2 == 0) {
                c.getMode().getModeController().doubleClick( e );
            } else {
                c.getMode().getModeController().plainClick( e );
            }
            e.consume();
        }
    }

    protected java.awt.Rectangle getControlRegion( java.awt.geom.Point2D p )
    {
        int side = 8;
        return new java.awt.Rectangle( (int) (p.getX() - side / 2), (int) (p.getY() - side / 2), side, side );
    }

    public void createTimer( java.awt.event.MouseEvent e )
    {
        stopTimerForDelayedSelection();
        controlRegionForDelayedSelection = getControlRegion( e.getPoint() );
        timerForDelayedSelection = new java.util.Timer();
        timerForDelayedSelection.schedule( new freemind.controller.NodeMouseMotionListener.timeDelayedSelection( c, e ), delayedSelectionEnabled.getValue() ? timeForDelayedSelection.getValue() : 0 );
    }

    protected void stopTimerForDelayedSelection()
    {
        if (timerForDelayedSelection != null) {
            timerForDelayedSelection.cancel();
        }
        timerForDelayedSelection = null;
        controlRegionForDelayedSelection = null;
    }

    protected class timeDelayedSelection extends java.util.TimerTask
    {

        private final freemind.controller.Controller c;

        private final java.awt.event.MouseEvent e;

        timeDelayedSelection( freemind.controller.Controller c, java.awt.event.MouseEvent e )
        {
            this.c = c;
            this.e = e;
        }

        public void run()
        {
            if (e.getY() == 0 && !c.getMode().getModeController().isBlocked() && c.getView().getSelecteds().size() <= 1) {
                c.getMode().getModeController().extendSelection( e );
            }
        }

    }

}
